package adrian.master.knowledgewar.server;

import java.io.IOException;
import java.io.PrintWriter;
import java.sql.Connection;
import java.sql.SQLException;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.sql.DataSource;

import org.json.JSONArray;
import org.json.JSONException;

import adrian.master.knowledgewar.server.constants.Constants;
import adrian.master.knowledgewar.server.logic.DatabaseConnection;
import adrian.master.knowledgewar.server.logic.GCMMessenger;
import adrian.master.knowledgewar.server.logic.GameLogic;

@WebServlet("/ChatServlet")
public class ChatServlet extends HttpServlet {
	private static final long serialVersionUID = 1L;
	DataSource datasource;
	
	public ChatServlet() {
		super();
	}
	

	public void init(ServletConfig config) throws ServletException {
		super.init(config);
		try {
			// Look up the JNDI data source only once at init time
			Context envCtx = (Context) new InitialContext().lookup("java:comp/env");
			datasource = (DataSource)envCtx.lookup("jdbc/knowledgewar");
		}
		catch (NamingException e) {
			e.printStackTrace();
		}
	}

	private Connection getConnection() throws SQLException {
		return datasource.getConnection();
	}
	
	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		response.setCharacterEncoding("UTF-8");
		PrintWriter responseWriter = response.getWriter();
		responseWriter.print("Chatservlet fungerer");
		responseWriter.flush();
	}
	
	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
//		System.out.println("Chatservlet aktiveres");
		Connection connection = null;
		String result = "";

		try {
			connection=getConnection();

			if(GameLogic.verifyLogin(request, connection)){
				String command = request.getParameter(Constants.COMMAND);

				if(command.equals(Constants.COMMAND_CHAT)){
					playerChat(connection, request);
				}

				response.setCharacterEncoding("UTF-8");
				PrintWriter responseWriter = response.getWriter();
				responseWriter.print(result);
				responseWriter.flush();
			}
		} catch (SQLException e) {
			// TODO Handle SQLException
			e.printStackTrace();
		} catch (JSONException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} 
	}
	
	private void playerChat(Connection con,HttpServletRequest request) throws JSONException, SQLException{
		String message = request.getParameter(Constants.PARAMETER_MESSAGE);
		String account = request.getParameter(Constants.PARAMETER_ACCOUNT);
//		JSONArray ar = new JSONArray(request.getParameter(Constants.PARAMETER_PLAYERS));
		JSONArray regIds = DatabaseConnection.getRegIDsforClosePlayers(con, account);
//		System.out.println("Chatservlet: message received. Sending. "+message+" "+regIds);
		GCMMessenger.sendChatMessage(message, regIds);
	}

}
