package adrian.master.knowledgewar.server.constants;


public class SQLStatements {
	
	//Fields in player
	public static final String PLAYER_TABLE = "player";
	public static final String PLAYER_KEY = "account";
	public static final String PLAYER_GCM = "gcm_id";
	public static final String PLAYER_PASSWORD = "password";
	public static final String PLAYER_AVAILABLE = "available";
	public static final String PLAYER_AREA = "area";
	public static final String PLAYER_GOLD = "gold";
//	public static final String PLAYER_XP = "xp";
	public static final String PLAYER_LATITUDE = "latitude";
	public static final String PLAYER_LONGITUDE = "longitude";
	public static final String PLAYER_BUSY = "busy";
	public static final String PLAYER_HEARTBEAT = "heartbeat_count";
	
	//Fields in battle
	public static final String BATTLE_TABLE = "battle";
	public static final String BATTLE_KEY = "id";
	public static final String BATTLE_RISK = "risk";
	public static final String BATTLE_SIZE = "size";
	public static final String BATTLE_FINISHED = "finished";
	public static final String BATTLE_STARTED = "started";
	
	//Fields in battles_in
	public static final String BATTLES_IN_TABLE = "battles_in";
	public static final String BATTLES_IN_PLAYER = "pid";
	public static final String BATTLES_IN_BATTLE = "bid";
	public static final String BATTLES_IN_DEBUFFS = "debuffs";
	public static final String BATTLES_IN_FINISHED = "finished";
	public static final String BATTLES_IN_SCORE = "score";
	public static final String BATTLES_IN_ATTACKER = "attacker";
	public static final String BATTLES_IN_WEAPONCOST = "weaponcost";
	
	//Fields in question
	public static final String QUESTION_TABLE = "question";
	public static final String QUESTION_QUESTION = "question";
	public static final String QUESTION_KEY = "id";
	public static final String QUESTION_ALT1 = "alt1";
	public static final String QUESTION_ALT2 = "alt2";
	public static final String QUESTION_ALT3 = "alt3";
	public static final String QUESTION_ALT4 = "alt4";
	public static final String QUESTION_CORRECT = "correct_alt";
	public static final String QUESTION_URL = "url";
	public static final String QUESTION_CATEGORY = "category";
	
	//Fields in question_battle
	public static final String QUESTION_BATTLE_TABLE = "question_battle";
	public static final String QUESTION_BATTLE_BATTLE = "bid";
	public static final String QUESTION_BATTLE_QUESTION = "qid";
	
	//Field in question_category
	public static final String QUESTION_CATEGORY_TABLE ="question_category";
	public static final String QUESTION_CATEGORY_KEY ="id";
	public static final String QUESTION_CATEGORY_NAME ="name";
	
	//Fields
	public static final String LAST_INSERT_ID_FIELD = "LAST_INSERT_ID()";
	public static final String COUNT_FIELD = "COUNT(*)";
	
	//Statements that use table "player"
	public static final String SET_PLAYER_BUSY = "UPDATE "+PLAYER_TABLE+" SET "+PLAYER_BUSY+"=? WHERE "+PLAYER_KEY+"=?";
	public static final String SET_PLAYER_NOT_BUSY = "UPDATE "+PLAYER_TABLE+" SET "+PLAYER_BUSY+"=0 WHERE "+PLAYER_KEY+"=?";
	public static final String GET_PLAYER_BUSY = "SELECT "+PLAYER_BUSY+" FROM "+PLAYER_TABLE+" WHERE "+PLAYER_KEY+"=?";
	public static final String REGISTER_STATEMENT = "INSERT INTO "+ PLAYER_TABLE +" ("+PLAYER_KEY+"," +PLAYER_PASSWORD+","+PLAYER_AREA+","+PLAYER_GOLD+") VALUES (?,?,?,?)";
	public static final String VERIFY_LOGIN_STATEMENT = "SELECT "+PLAYER_KEY +" FROM "+PLAYER_TABLE +" WHERE "+PLAYER_KEY +"=? AND "+PLAYER_PASSWORD +"=?";
	public static final String LOGIN_STATEMENT = "UPDATE "+PLAYER_TABLE+" SET "+PLAYER_AVAILABLE+"=1, "+PLAYER_BUSY+"=0, "+PLAYER_HEARTBEAT+"=0 WHERE "+PLAYER_KEY+"=?";
	public static final String LOGOUT_STATEMENT = "UPDATE "+PLAYER_TABLE+" SET "+PLAYER_AVAILABLE+"=0, "+PLAYER_BUSY+"=0 WHERE "+PLAYER_KEY+"=?";
	public static final String CHECK_ACCOUNTNAMEAVAILABILITY_STATEMENT = "SELECT "+PLAYER_KEY +" FROM "+PLAYER_TABLE +" WHERE "+PLAYER_KEY +"=?";
	public static final String VERIFY_GCM_STATEMENT = "SELECT "+PLAYER_GCM +" FROM "+PLAYER_TABLE +" WHERE "+PLAYER_KEY +"=?";
	public static final String UPDATE_GCM_STATEMENT = "UPDATE "+PLAYER_TABLE +" SET "+PLAYER_GCM +"=? WHERE "+PLAYER_KEY +"=?";
	public static final String GET_PLAYERS_STATEMENT = "SELECT "+PLAYER_KEY +", "+PLAYER_AREA+", "+PLAYER_BUSY+" FROM "+PLAYER_TABLE +" WHERE "+PLAYER_KEY+"!=? AND "+PLAYER_AVAILABLE+"=1";
	public static final String GET_CLOSE_PLAYERS_STATEMENT = "SELECT "+ PLAYER_KEY+", "+PLAYER_AREA+", "+PLAYER_BUSY+" FROM "+PLAYER_TABLE +" WHERE "+PLAYER_AVAILABLE+"=1 AND "+PLAYER_KEY+"!=? AND "+PLAYER_LATITUDE+"<?+"+Constants.CLOSE_PLAYER+" AND "+PLAYER_LATITUDE+">?-"+Constants.CLOSE_PLAYER+" AND "+PLAYER_LONGITUDE+"<?+"+Constants.CLOSE_PLAYER+" AND "+PLAYER_LONGITUDE+">?-"+Constants.CLOSE_PLAYER; //TODO Temporary "Close players" for testing purposes
	public static final String GET_PLAYER_STATEMENT = "SELECT * FROM "+ PLAYER_TABLE+" WHERE "+ PLAYER_KEY+"=?";
	public static final String GET_PLAYER_REGID = "SELECT "+PLAYER_KEY+","+ PLAYER_GCM+" FROM "+ PLAYER_TABLE+" WHERE "+ PLAYER_KEY+"=?";
	public static final String GET_MULTIPLE_PLAYER_REGID_ADDITION = " OR "+PLAYER_KEY+"=?";
	public static final String GET_PLAYER_INFO_FOR_BATTLE = "SELECT "+PLAYER_KEY+", "+PLAYER_AREA+", "+PLAYER_GOLD+", "+BATTLES_IN_SCORE+", "+BATTLES_IN_WEAPONCOST+", "+BATTLES_IN_ATTACKER+", "+PLAYER_GCM+" FROM "+PLAYER_TABLE+" P, "+BATTLES_IN_TABLE+" B WHERE B."+BATTLES_IN_BATTLE+"=? AND P."+PLAYER_KEY+"=B."+BATTLES_IN_PLAYER+"";
	public static final String GET_PLAYER_STATS = "SELECT "+PLAYER_KEY+", "+PLAYER_AREA+", "+PLAYER_GOLD+", "+PLAYER_BUSY+" FROM "+PLAYER_TABLE+" WHERE "+PLAYER_KEY+"=?";
	public static final String GET_PLAYER_INFO = "SELECT "+PLAYER_KEY+", "+PLAYER_GOLD+", "+PLAYER_GCM+", "+PLAYER_AREA+" FROM "+PLAYER_TABLE+" WHERE "+PLAYER_KEY+"=?";
	public static final String SET_PLAYER_INFO_AFTER_BATTLE = "UPDATE "+PLAYER_TABLE+" SET "+PLAYER_GOLD+"=?, "+PLAYER_AREA+"=? WHERE "+PLAYER_KEY+"=?";
	public static final String UPDATE_PLAYER_POSITION = "UPDATE "+PLAYER_TABLE+" SET "+PLAYER_LATITUDE+"=?,"+PLAYER_LONGITUDE+"=?, "+PLAYER_HEARTBEAT+"=0 WHERE "+PLAYER_KEY+"=?";
	public static final String UPDATE_PLAYER_STATS = "UPDATE "+PLAYER_TABLE+" SET "+PLAYER_GOLD+"=?, "+PLAYER_AREA+"=? WHERE "+PLAYER_KEY+"=?";
	public static final String GET_CLOSE_PLAYERS_REGIDS = "SELECT "+PLAYER_KEY+", "+PLAYER_GCM+" FROM "+PLAYER_TABLE+" WHERE "+PLAYER_LATITUDE+"<?+"+Constants.CLOSE_PLAYER+" AND "+PLAYER_LATITUDE+">?-"+Constants.CLOSE_PLAYER+" AND "+PLAYER_LONGITUDE+"<?+"+Constants.CLOSE_PLAYER+" AND "+PLAYER_LONGITUDE+">?-"+Constants.CLOSE_PLAYER;
//	public static final String GET_CLOSE_PLAYERS_REGIDS = "SELECT "+PLAYER_KEY+", "+PLAYER_GCM+" FROM "+PLAYER_TABLE+" WHERE 1=1"; //TODO Temporary "Close players" for testing purposes
	public static final String GET_PLAYER_LATITUDE_LONGITUDE = "SELECT "+PLAYER_LATITUDE+", "+PLAYER_LONGITUDE+" FROM "+PLAYER_TABLE+" WHERE "+PLAYER_KEY+" = ?";
	public static final String INCREMENT_PLAYER_HEARTBEAT = "UPDATE "+PLAYER_TABLE+" SET "+PLAYER_HEARTBEAT+"="+PLAYER_HEARTBEAT+"+1 WHERE "+PLAYER_AVAILABLE+"=1";
	public static final String CHECK_HEARTBEAT_AND_LOGOUT = "UPDATE "+PLAYER_TABLE+" SET "+PLAYER_AVAILABLE+"=0,"+PLAYER_BUSY+"=0,"+PLAYER_HEARTBEAT+"=0 WHERE "+PLAYER_HEARTBEAT+">"+Constants.HEARTBEAT_COUNT_LIMIT;
	
	public static final String GET_PLAYERS_IN_BATTLE = "SELECT "+PLAYER_GCM+" FROM "+PLAYER_TABLE+" P, "+BATTLES_IN_TABLE+" B WHERE B."+BATTLES_IN_BATTLE+"=? AND P."+PLAYER_KEY+"=B."+BATTLES_IN_PLAYER;
	public static final String GET_OPPONENT_IN_BATTLE = "SELECT "+PLAYER_KEY+", "+PLAYER_AREA+" FROM "+PLAYER_TABLE+" P, "+BATTLES_IN_TABLE+" B WHERE B."+BATTLES_IN_BATTLE+"=? AND P."+PLAYER_KEY+"=B."+BATTLES_IN_PLAYER+" AND B."+BATTLES_IN_PLAYER+"!=?";
	
	//Statements that use table "battle"
	public static final String CREATE_BATTLE_STATEMENT = "INSERT INTO "+BATTLE_TABLE +" ("+BATTLE_RISK +","+BATTLE_SIZE+") VALUES (?,?)"; 
	public static final String GET_LAST_INSERT_ID = "SELECT LAST_INSERT_ID()";
	public static final String START_BATTLE_STATEMENT = "UPDATE "+BATTLE_TABLE +" SET "+BATTLE_STARTED+"=1 WHERE id=?";
	public static final String HAS_BATTLE_STARTED = "SELECT "+BATTLE_STARTED+" FROM "+BATTLE_TABLE+" WHERE "+BATTLE_KEY+"=?";
	public static final String GET_BATTLE_INFO = "SELECT * FROM "+BATTLE_TABLE+" WHERE "+BATTLE_KEY+"=?";
	public static final String GET_BATTLE_RISK_AND_SIZE = "SELECT "+BATTLE_RISK+", "+BATTLE_SIZE+" FROM "+BATTLE_TABLE+" WHERE "+BATTLE_KEY+"=?";
	public static final String SET_BATTLE_FINISHED = "UPDATE "+BATTLE_TABLE+" SET "+BATTLE_FINISHED+"=1 WHERE "+BATTLE_KEY+"=?";
	
	//Statements that use table "battles_in"
	public static final String IS_A_PLAYER_NOT_FINISHED = "SELECT "+PLAYER_KEY+" FROM "+BATTLES_IN_TABLE+","+PLAYER_TABLE+" WHERE "+BATTLES_IN_BATTLE+"=? AND "+BATTLES_IN_FINISHED+"=0 AND "+PLAYER_KEY+"="+BATTLES_IN_PLAYER;
	public static final String GET_DEBUFFS_STATEMENT = "SELECT "+BATTLES_IN_DEBUFFS +" FROM "+BATTLES_IN_TABLE +" WHERE "+BATTLES_IN_PLAYER +"!=? and "+ BATTLES_IN_BATTLE+"=?";
	public static final String SET_DEBUFFS_STATEMENT = "UPDATE "+BATTLES_IN_TABLE +" SET "+BATTLES_IN_DEBUFFS +"=? WHERE "+BATTLES_IN_PLAYER+"!=? AND "+ BATTLES_IN_BATTLE+"=?";
	public static final String GET_ATTACKS_STATEMENT ="SELECT "+BATTLES_IN_DEBUFFS +" FROM "+BATTLES_IN_TABLE +" WHERE "+BATTLES_IN_PLAYER+"=? AND "+BATTLES_IN_BATTLE +"=?";
	public static final String SET_ATTACKS_STATEMENT = "UPDATE "+BATTLES_IN_TABLE+" SET "+BATTLES_IN_DEBUFFS+"=? WHERE "+BATTLES_IN_PLAYER+"=? AND "+BATTLES_IN_BATTLE+"=?";
	public static final String PLAYER_FINISHED_STATEMENT = "UPDATE "+BATTLES_IN_TABLE+" SET "+BATTLES_IN_FINISHED+"=1, "+ BATTLES_IN_SCORE+"=?, "+BATTLES_IN_WEAPONCOST+"=? WHERE "+BATTLES_IN_PLAYER+"=? AND "+BATTLES_IN_BATTLE+"=?";
	public static final String IS_PLAYER_FINISHED_QUERY = "SELECT "+BATTLES_IN_FINISHED+" FROM "+BATTLES_IN_TABLE+" WHERE "+BATTLES_IN_BATTLE+"=? AND "+BATTLES_IN_PLAYER+"!=?";
	public static final String ASSOCIATE_PLAYERS_WITH_BATTLE_STATEMENT = "INSERT INTO "+BATTLES_IN_TABLE+" ("+BATTLES_IN_PLAYER+", "+BATTLES_IN_BATTLE+", "+BATTLES_IN_ATTACKER+") VALUES (?,?,?),(?,?,?)";
	public static final String IS_PLAYERS_FINISHED = "SELECT "+COUNT_FIELD+" FROM "+BATTLES_IN_TABLE+" WHERE "+BATTLES_IN_BATTLE+"=? AND "+BATTLES_IN_FINISHED+"=1";
	public static final String GET_BATTLE_RESULT = "SELECT "+BATTLES_IN_SCORE+","+BATTLES_IN_PLAYER+" FROM "+BATTLES_IN_TABLE+" WHERE "+BATTLES_IN_BATTLE+"=?";
	public static final String GET_OTHER_PLAYERS_IN_UNSTARTED_DUELS = "select P."+PLAYER_KEY+", P."+PLAYER_GCM+" from "+PLAYER_TABLE+" P, "+BATTLES_IN_TABLE+" BI where BI."+BATTLES_IN_PLAYER+" != ? and BI."+BATTLES_IN_PLAYER+"=P."+PLAYER_KEY+" and BI."+BATTLES_IN_BATTLE+" = (select B."+BATTLE_KEY+" from "+BATTLES_IN_TABLE+" B, "+BATTLES_IN_TABLE+" BI where BI."+BATTLES_IN_PLAYER+"=? and BI."+BATTLES_IN_BATTLE+"=B."+BATTLE_KEY+" and B."+BATTLE_STARTED+"=0);";
	public static final String MARK_UNSTARTED_DUELS_AS_FINISHED = "update "+BATTLE_KEY+" set "+BATTLE_STARTED+"=1, "+BATTLE_FINISHED+"=1 where id=(select B."+BATTLE_KEY+" from "+BATTLES_IN_TABLE+" B, "+BATTLES_IN_TABLE+" BI where BI."+BATTLES_IN_PLAYER+"=? and BI."+BATTLES_IN_BATTLE+"=B."+BATTLE_KEY+" and B."+BATTLE_STARTED+"=0)";
	
	//Statements that use table "question"
	public static final String GET_NUMBER_OF_QUESTIONS = "SELECT COUNT(*) FROM "+QUESTION_TABLE;
	public static final String GET_QUESTION_STATEMENT = "SELECT * FROM question WHERE id=?";
	public static final String GET_ALL_QUESTIONS_IN_CATEGROY = "SELECT Q."+QUESTION_KEY+" FROM "+QUESTION_TABLE+" Q, "+QUESTION_CATEGORY_TABLE+" C WHERE C."+QUESTION_CATEGORY_KEY+"=? AND C."+QUESTION_CATEGORY_KEY+"=Q."+QUESTION_CATEGORY;
	public static final String GET_ALL_QUESTIONS = "SELECT "+QUESTION_KEY+" FROM "+QUESTION_TABLE;
	//	public static final String GET_QUESTIONS_FOR_BATTLE = "SELECT "+QUESTION_KEY+","+QUESTION_QUESTION+","+QUESTION_ALT1+","+QUESTION_ALT2+","+
//	QUESTION_ALT3+","+QUESTION_ALT4+","+QUESTION_CORRECT+" FROM "+QUESTION_TABLE+" Q, "+QUESTION_BATTLE_TABLE+
//	" B WHERE B."+QUESTION_BATTLE_BATTLE+"=? AND B."+QUESTION_BATTLE_QUESTION+"=Q."+QUESTION_KEY+"";
	public static final String GET_QUESTIONS_FOR_BATTLE = "SELECT * FROM "+QUESTION_TABLE+" Q, "+QUESTION_BATTLE_TABLE+
			" B WHERE B."+QUESTION_BATTLE_BATTLE+"=? AND B."+QUESTION_BATTLE_QUESTION+"=Q."+QUESTION_KEY+"";
	
	//Statements that use table "question_battle"
	public static final String INSERT_QUESTION_BATTLE_VALUES = "INSERT INTO "+QUESTION_BATTLE_TABLE+" VALUES (?,?)";
	public static final String INSERT_ADDITIONAL_QUESTION_BATTLE_VALUES = ",(?,?)";
	
	//Statements that use table "question_category"
	public static final String GET_CATEGORY_FROM_ID = "SELECT "+QUESTION_CATEGORY_NAME+" FROM "+QUESTION_CATEGORY_TABLE+" WHERE "+QUESTION_CATEGORY_KEY+"=?";
	public static final String GET_CATEGORIES ="SELECT "+QUESTION_CATEGORY_KEY+", "+QUESTION_CATEGORY_NAME+" FROM "+QUESTION_CATEGORY_TABLE;
	
}
