package adrian.master.knowledgewar.server.gameconcepts;


public class Building {
	
	private int x, y;
	private String mType;
	private String mName;
	private int mRank;
	private int mValue;
	private int mHealth;
	private int mUpgradeCost;
	
	private float mGoldBonus;
	private int mDamageBonus;
	private int mHealthBonus=0;
	private float mGoldPenalty;
	
	private boolean mGlobal = false;
	
//	private double expProfitModifier=1;
//	private double opponentExpModifier=1;
	
	public Building(int x, int y, String type, int rank){
		this.x=x;
		this.y=y;
		this.mType=type;
		this.mRank = rank;
	}
	
	public Building(String type, String name, int rank, int value, int health, boolean global, float goldBonus, int damageBonus,
			int healthBonus, float goldPenalty, int upgradeCost){
		this.mType = type;
		this.mName = name;
		this.mRank = rank;
		this.mValue = value;
		this.mHealth = health;
		this.mUpgradeCost = upgradeCost;
		
		this.mGoldBonus = goldBonus;
		this.mDamageBonus = damageBonus;
		this.mHealthBonus = healthBonus;
		this.mGoldPenalty = goldPenalty;
		
		this.mGlobal = global;
	}
	
	/**
	 * Copy constructor to make a new copy of a building template.
	 * @return
	 */
	public static Building getNewBuilding(Building b){
		return new Building(b.getType(),b.getName(), b.getRank(), b.getValue(), b.getHealth(), b.isGlobal(), b.getGoldBonus(),
				b.getDamageBonus(), b.getHealthBonus(), b.getGoldPenalty(), b.getUpgradeCost());
	}
	
	public String getType(){
		return mType;
	}
	
	
	public void setBonuses(int health, int healthBonus, int damageBonus, float profitModifier, 
			float opponentGoldModifier, int buildingValue, boolean global){
		this.mHealth=health;
		this.mHealthBonus=healthBonus;
		this.mDamageBonus=damageBonus;
		this.mGoldBonus=profitModifier;
		this.mGoldPenalty=opponentGoldModifier;
		this.mGlobal=global;
		this.mValue=buildingValue;
		
	}
	
	/**
	 * Returns the string-representation of this building. The format is
	 * <type>:<rank>:<x-coordinate>,<y-coordinate>
	 */
	public String toString(){
		return ";"+mType+":"+mRank+":"+x+","+y;
	}
	

	public int getX(){
		return x;
	}
	
	public int getY(){
		return y;
	}
	
	public void setX(int px){
		this.x=px;
	}
	
	public void setY(int py){
		this.y=py;
	}
	
	public boolean isGlobal(){
		return mGlobal;
	}
	
	public String getName(){
		return mName;
	}
	
	public int getHealth(){
		return mHealth;
	}
	
	public int getHealthBonus(){
		return mHealthBonus;
	}
	
	public float getGoldBonus(){
		return mGoldBonus;
	}
	
	public float getGoldPenalty(){
		return mGoldPenalty;
	}
		
	public int getDamageBonus(){
		return mDamageBonus;
	}
	
	public int getValue(){
		return mValue;
	}
	
	public int getUpgradeCost(){
		return mUpgradeCost;
	}
		
	public int getRank(){
		return mRank;
	}
	
	public void updatePosition(int modifier){
		x+=modifier;
		y+=modifier;
	}
	
//	private void parseInputString(String input){
//		int indexOfSeparator = input.indexOf(':');
//		int indexOfCoordinateSeparator = input.indexOf(',');
//		String type = input.substring(0,indexOfSeparator);
//		int x=Integer.parseInt(input.substring(indexOfSeparator+1, indexOfCoordinateSeparator));
//		int y=Integer.parseInt(input.substring(indexOfCoordinateSeparator+1, input.length()));
//		
//		this.x=x;
//		this.y=y;
//		this.type=type;
//	}
	
	

}
