package adrian.master.knowledgewar.server.logic;

import java.sql.Connection;
import java.sql.SQLException;

import org.json.JSONArray;
import org.json.JSONException;


public class AnswerHandler {
	
	public static String handleAnswer(Connection con, String account, String battleNr, String newDebuff) throws SQLException{
		//Add the new debuff to the opponents debuff-list
		String debuffs = DatabaseConnection.getDebuffs(con, battleNr, account);
		String updatedDebuffs = DebuffStringHandler.appendDebuff(debuffs, newDebuff);
		DatabaseConnection.setDebuffs(con, battleNr, account, updatedDebuffs);
		
		//Extract player attacks from database, return the one that will affect this round, and write the rest back to database
		String attacks = DatabaseConnection.getAttacks(con, battleNr, account);
		String[] updatedAttacks = DebuffStringHandler.getAttack(attacks);
		DatabaseConnection.setAttacks(con, battleNr, account, updatedAttacks[1]);
		
		return updatedAttacks[0];
	}
	
	public static boolean handleFinished(Connection con, String account, String battleNr, String score, String weaponcost) throws SQLException, JSONException{
		DatabaseConnection.playerFinished(con, account, battleNr, score,weaponcost);
		
		boolean otherPlayerFinished = DatabaseConnection.isOtherPlayerFinished(con, account, battleNr);
		
		if(otherPlayerFinished){
			GameLogic.calculateBattleResult(con, battleNr);
		}
		
		return otherPlayerFinished;
		
	}

}
