package adrian.master.knowledgewar;

import adrian.master.knowledgewar.logic.Constants;
import adrian.master.knowledgewar.logic.PushMessageHandler;
import adrian.master.knowledgewar.logic.Server;
import adrian.master.knowledgewar.logic.UserFunctions;
import android.content.Context;
import android.content.Intent;
import android.util.Log;

import com.google.android.gcm.GCMBaseIntentService;

public class GCMIntentService extends GCMBaseIntentService {

	@Override
	protected void onError(Context arg0, String arg1) {
		Log.v("Knowledgewar", "Error er: "+arg1);

	}

	@Override
	protected void onMessage(Context applicationContext, Intent intent) {
		
		String targetAccount = intent.getStringExtra(Constants.PARAMETER_ACCOUNT);
		String account = UserFunctions.getUserAccount(applicationContext);
		
		Log.v("Knowledgewar, GCM", "Innlogget konto: "+account+", Etterspurt konto: "+targetAccount);
		
		if(UserFunctions.isSpecificUserLoggedIn(applicationContext, targetAccount)){
			String command = intent.getStringExtra(Constants.COMMAND);
			
			//The user has been challenged to a duel.
			if(command.equals(Constants.COMMAND_CHALLENGE)){
				PushMessageHandler.receiveChallenge(applicationContext, intent);
			}
			//The user challenged someone else to a duel, and that user has accepted the challenge
			else if(command.equals(Constants.COMMAND_ACCEPT)){
				PushMessageHandler.challengeAccepted(applicationContext, intent);
			}
			//The user challenged someone else to a duel, and that user has declined the challenge
			else if(command.equals(Constants.COMMAND_CHALLENGE_DECLINED)){
				PushMessageHandler.challengeDeclined(applicationContext, intent);
			}
			//The opponent accepted another challenge
			else if(command.equals(Constants.COMMAND_CHALLENGE_IMPOSSIBLE)){
				PushMessageHandler.challengeImpossible(applicationContext, intent);
			}
			//You declined a challenge, and now you receive the result of the battle
			else if(command.equals(Constants.COMMAND_YOU_DECLINED_CHALLENGE)){
				PushMessageHandler.youDeclinedChallenge(applicationContext, intent);
			}
			//A battle is about to start
			else if(command.equals(Constants.COMMAND_STARTROUND)){
				PushMessageHandler.startRound(applicationContext, intent);
			}
			else if(command.equals(Constants.COMMAND_FINISH)){
				PushMessageHandler.battleFinished(applicationContext, intent);
			}
			else if(command.equals(Constants.COMMAND_CHAT)){
				PushMessageHandler.receiveChatMessage(applicationContext, intent);
			}
		}
		
	}

	@Override
	protected void onRegistered(Context applicationContext, String regId) {
		Server.registerGCM(regId, applicationContext);

	}

	@Override
	protected void onUnregistered(Context applicationContext, String regId) {
		Server.unRegisterGCM(applicationContext);
	}

}
