package adrian.master.knowledgewar;

import adrian.master.knowledgewar.logic.Server;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.location.Location;
import android.os.AsyncTask;
import android.util.Log;

import com.commonsware.cwac.locpoll.LocationPoller;

public class LocationReceiver extends BroadcastReceiver {

	@Override
	public void onReceive(Context arg0, Intent intent) {
		Location loc=(Location)intent.getExtras().get(LocationPoller.EXTRA_LOCATION);
        String msg;

        if (loc==null) {
            msg=intent.getStringExtra(LocationPoller.EXTRA_ERROR);
        }
        else {
            msg=loc.toString();
            double latitude = loc.getLatitude();
            double longitude = loc.getLongitude();
            PositionUpdater updater = new PositionUpdater(arg0);
            updater.execute(latitude, longitude);
        }

        if (msg==null) {
            msg="Invalid broadcast received!";
        }
        Log.v("Knowledgewar.LocationReceiver", msg);

	}
	
	private class PositionUpdater extends AsyncTask<Double, Void, Void>{
		
		private Context context;
		
		public PositionUpdater(Context con){
			context=con;
		}

		@Override
		protected Void doInBackground(Double... params) {
			Server.updatePosition(context, params[0], params[1]);
			return null;
		}
		
	}

}
