package adrian.master.knowledgewar.gameactivities;

import java.util.ArrayList;

import org.andengine.engine.camera.Camera;
import org.andengine.engine.camera.ZoomCamera;
import org.andengine.engine.handler.timer.ITimerCallback;
import org.andengine.engine.handler.timer.TimerHandler;
import org.andengine.engine.options.EngineOptions;
import org.andengine.engine.options.ScreenOrientation;
import org.andengine.engine.options.resolutionpolicy.RatioResolutionPolicy;
import org.andengine.entity.modifier.AlphaModifier;
import org.andengine.entity.modifier.SequenceEntityModifier;
import org.andengine.entity.primitive.Rectangle;
import org.andengine.entity.scene.Scene;
import org.andengine.opengl.font.Font;
import org.andengine.opengl.font.FontFactory;
import org.andengine.opengl.texture.TextureOptions;
import org.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlas;
import org.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlasTextureRegionFactory;
import org.andengine.opengl.texture.region.TextureRegion;
import org.andengine.opengl.texture.region.TiledTextureRegion;
import org.andengine.ui.activity.SimpleLayoutGameActivity;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import adrian.master.knowledgewar.R;
import adrian.master.knowledgewar.activities.LoginActivity;
import adrian.master.knowledgewar.gameconcepts.BuildingFactory;
import adrian.master.knowledgewar.gameconcepts.Challenge;
import adrian.master.knowledgewar.gameconcepts.Player;
import adrian.master.knowledgewar.gameconcepts.WeaponFactory;
import adrian.master.knowledgewar.interfaces.MainActivityInterface;
import adrian.master.knowledgewar.logic.Constants;
import adrian.master.knowledgewar.logic.Database;
import adrian.master.knowledgewar.logic.Server;
import adrian.master.knowledgewar.logic.UserFunctions;
import adrian.master.knowledgewar.misc.OwnResolutionPolicy;
import adrian.master.knowledgewar.scenes.ChallengeScene;
import adrian.master.knowledgewar.scenes.HowToPlayScene;
import adrian.master.knowledgewar.scenes.MainMenuScene;
import adrian.master.knowledgewar.scenes.MapScene;
import adrian.master.knowledgewar.scenes.OwnTribeScene;
import adrian.master.knowledgewar.scenes.PendingChallengesScene;
import adrian.master.knowledgewar.scenes.QuestionsScene;
import adrian.master.knowledgewar.scenes.TransitionScene;
import adrian.master.knowledgewar.subscenes.ChatHUD;
import android.annotation.SuppressLint;
import android.app.AlertDialog;
import android.app.Dialog;
import android.app.backup.RestoreObserver;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.res.Resources;
import android.graphics.Typeface;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnKeyListener;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.Toast;

public class MainActivity extends SimpleLayoutGameActivity{

	public static int CAMERA_HEIGHT = Constants.CAMERA_HEIGHT;
	public static int CAMERA_WIDTH = Constants.CAMERA_WIDTH ;
	public static MainActivity instance;

	public ZoomCamera mZoomCamera;
	private MainMenuScene mScene;
	private MapScene mMap;
	private OwnTribeScene mOwnTribe;
	private ChallengeScene mChallengeScene;
	private PendingChallengesScene mPendingScene;
	private MainActivityInterface mActiveScene;
	private HowToPlayScene mInstructionScene;
	private QuestionsScene mQuestionsScene;

	public Camera mSecondCamera;

	private boolean isAtMainMenu=true;
	private boolean inMiddleOfTransition=false;

	private BitmapTextureAtlas mRedTile, mYellowTile, mGreenTile, mMoney;
	private BitmapTextureAtlas mSand;
	private BitmapTextureAtlas mOwnTile;
	private BitmapTextureAtlas mCart, mCartStar, mCartSquare, mCartTriangle, mCartCircle, mCartPentagon;
	private BitmapTextureAtlas mDune;
	private BitmapTextureAtlas mDuneBackground;
	private BitmapTextureAtlas mButton, mWhiteButton;
	private BitmapTextureAtlas mBlankTile;
	private BitmapTextureAtlas mBlack;
	private BitmapTextureAtlas mHorizontalLine, mVerticalLine;
	private BitmapTextureAtlas mRedBar, mBlueBar;
	private BitmapTextureAtlas mChatBackground, mChatTab;
	private BitmapTextureAtlas mHowToPlay,mHowToPlay2,mHowToPlay3;
	private BitmapTextureAtlas mChicken, mCow, mNinja1,mNinja2,mFan1,mFan2,mWand1,mWand2;
	private BitmapTextureAtlas mLeatherBackground, mPaperBackground, mCube, mLogo;

	public TextureRegion mRedTileTexture, mYellowTileTexture, mGreenTileTexture, mMoneyTexture;
	public TextureRegion mSandTexture;
	public TextureRegion mOwnTileTexture;
	public TextureRegion mCartTexture, mCartStarTexture, mCartSquareTexture, mCartTriangleTexture, mCartCircleTexture, mCartPentagonTexture;
	public TextureRegion mDuneTexture;
	public TextureRegion mDuneBackgroundTexture;
	public TextureRegion mButtonTexture, mWhiteButtonTexture;
	public TextureRegion mBlankTileTexture;
	public TextureRegion mBlackTexture;
	public TextureRegion mHorizontalLineTexture, mVerticalLineTexture;
	public TextureRegion mRedBarTexture, mBlueBarTexture;
	public TextureRegion mChatBackTexture, mChatTabTexture;
	public TextureRegion mHowToPlayTexture,mHowToPlayTexture2,mHowToPlayTexture3;
	public TextureRegion mChickenTexture, mCowTexture, mNinja1Texture,mNinja2Texture,mFan1Texture,mFan2Texture,mWand1Texture,mWand2Texture;
	public TextureRegion mLeatherTexture, mPaperTexture, mLogoTexture;
	public TiledTextureRegion mCubeTexture;

	public Font mFontBold, mFont; 
	public Font mSmallFontBold, mSmallFont;
	public Font mMediumFont, mMediumFontBold;
	public Font mBigFont, mBigFontBold;

	public Resources mRes;
	private EditText mChatInput;
	private Button mChatButton;
	private View mLayout;
	private OwnResolutionPolicy mResPolicy;

	//	public Database mQuestionDatabase;

	private ChatHUD mChatHUD;
	private Dialog mDialog;

	private String[] mString;
	private int[] mInt;
	private AsyncTask mActiveTask;

	@Override
	protected void onCreate(Bundle pSavedInstanceState) {
		super.onCreate(pSavedInstanceState);

		//		mQuestionDatabase = Database.getInstance(getApplicationContext());
		//		mQuestionDatabase.open();
	}

	@Override
	protected void onSetContentView() {
		super.onSetContentView();

		this.mChatInput = (EditText)this.findViewById(R.id.edittext_text);

		mChatInput.setOnKeyListener(new OnKeyListener() {

			public boolean onKey(View v, int keyCode, KeyEvent event)
			{
				if (event.getAction() == KeyEvent.ACTION_DOWN)
				{
					switch (keyCode)
					{
					case KeyEvent.KEYCODE_DPAD_CENTER:
					case KeyEvent.KEYCODE_ENTER:
						sendChat();
						return true;
					default:
						break;
					}
				}
				return false;
			}
		});
		this.mChatButton= (Button)this.findViewById(R.id.chat_button);
		this.mChatButton.setOnClickListener(new OnClickListener(){

			@Override
			public void onClick(View v) {
				sendChat();
			}

		});
		this.mLayout = findViewById(R.id.chatlayout);
		instance = this;

		WeaponFactory.parseXML(getApplicationContext());
		BuildingFactory.parseXML(this);
		UserFunctions.getPlayers(getApplicationContext());
	}

	/**
	 * Sends messages that is entered in the chat.
	 */
	private void sendChat(){
		String message = mChatInput.getText().toString();
		if(message!=null && !message.equals("")){
			UserFunctions.sendChatMessage(getApplicationContext(), message);
			mChatInput.setText("");					
		}
	}



	@Override
	protected int getLayoutID() {
		return R.layout.edittextlayout;
	}

	@Override
	protected int getRenderSurfaceViewID() {
		return R.id.edittext_rendersurfaceview;
	}

	@Override
	public EngineOptions onCreateEngineOptions() {

		mZoomCamera = new ZoomCamera(0, 0, CAMERA_WIDTH, CAMERA_HEIGHT);
		//		mResPolicy = new OwnResolutionPolicy(CAMERA_WIDTH, CAMERA_HEIGHT);
		RatioResolutionPolicy policy = new RatioResolutionPolicy(CAMERA_WIDTH, CAMERA_HEIGHT);
		final EngineOptions engineOptions = new EngineOptions(false, ScreenOrientation.PORTRAIT_FIXED, policy, this.mZoomCamera);
		return engineOptions;
	}


	@SuppressLint("NewApi")
	@Override
	protected void onCreateResources() {



		BitmapTextureAtlasTextureRegionFactory.setAssetBasePath("gfx/");

		this.mRedTile = new BitmapTextureAtlas(this.getTextureManager(), Constants.TILE_SIZE, Constants.TILE_SIZE, TextureOptions.REPEATING_BILINEAR_PREMULTIPLYALPHA);
		mRedTileTexture =BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mRedTile, this, "redtile.png", 0, 0);
		this.mRedTile.load();

		this.mYellowTile = new BitmapTextureAtlas(this.getTextureManager(), Constants.TILE_SIZE, Constants.TILE_SIZE, TextureOptions.REPEATING_BILINEAR_PREMULTIPLYALPHA);
		mYellowTileTexture =BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mYellowTile, this, "yellowtile.png", 0, 0);
		this.mYellowTile.load();

		this.mGreenTile = new BitmapTextureAtlas(this.getTextureManager(), Constants.TILE_SIZE, Constants.TILE_SIZE, TextureOptions.REPEATING_BILINEAR_PREMULTIPLYALPHA);
		mGreenTileTexture =BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mGreenTile, this, "greentile.png", 0, 0);
		this.mGreenTile.load();

		this.mBlankTile = new BitmapTextureAtlas(this.getTextureManager(), Constants.TILE_SIZE, Constants.TILE_SIZE, TextureOptions.REPEATING_BILINEAR_PREMULTIPLYALPHA);
		mBlankTileTexture = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mBlankTile, this, "blanktile.png", 0, 0);
		this.mBlankTile.load();

		this.mBlack = new BitmapTextureAtlas(this.getTextureManager(), Constants.TILE_SIZE, Constants.TILE_SIZE, TextureOptions.REPEATING_BILINEAR_PREMULTIPLYALPHA);
		this.mBlackTexture = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mBlack, this, "black.png", 0,0);
		this.mBlack.load();

		this.mHorizontalLine = new BitmapTextureAtlas(this.getTextureManager(), Constants.TILE_SIZE, 2, TextureOptions.REPEATING_BILINEAR_PREMULTIPLYALPHA);
		this.mHorizontalLineTexture = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mHorizontalLine, this, "horizontalline.png", 0,0);
		this.mHorizontalLine.load();

		this.mVerticalLine = new BitmapTextureAtlas(this.getTextureManager(), 2,Constants.TILE_SIZE,  TextureOptions.REPEATING_BILINEAR_PREMULTIPLYALPHA);
		this.mVerticalLineTexture = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mVerticalLine, this, "verticalline.png", 0,0);
		this.mVerticalLine.load();

		this.mSand = new BitmapTextureAtlas(this.getTextureManager(), Constants.TILE_SIZE*8, Constants.TILE_SIZE*8, TextureOptions.REPEATING_BILINEAR_PREMULTIPLYALPHA);
		this.mSandTexture = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mSand, this, "sand.png", 0,0);
		this.mSand.load();

		this.mOwnTile = new BitmapTextureAtlas(this.getTextureManager(), Constants.TILE_SIZE, Constants.TILE_SIZE, TextureOptions.REPEATING_BILINEAR_PREMULTIPLYALPHA);
		this.mOwnTileTexture = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mOwnTile, this, "owntile2.png", 0,0);
		this.mOwnTile.load();

		this.mCart = new BitmapTextureAtlas(this.getTextureManager(), 256, 192, TextureOptions.BILINEAR_PREMULTIPLYALPHA);
		this.mCartTexture = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mCart, this, "cart.png", 0, 0);
		this.mCart.load();

		this.mCartCircle = new BitmapTextureAtlas(this.getTextureManager(), 256, 192, TextureOptions.BILINEAR_PREMULTIPLYALPHA);
		this.mCartCircleTexture = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mCartCircle, this, "cart_circle.png", 0, 0);
		this.mCartCircle.load();

		this.mCartStar = new BitmapTextureAtlas(this.getTextureManager(), 256, 192, TextureOptions.BILINEAR_PREMULTIPLYALPHA);
		this.mCartStarTexture = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mCartStar, this, "cart_star.png", 0, 0);
		this.mCartStar.load();

		this.mCartSquare = new BitmapTextureAtlas(this.getTextureManager(), 256, 192, TextureOptions.BILINEAR_PREMULTIPLYALPHA);
		this.mCartSquareTexture = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mCartSquare, this, "cart_square.png", 0, 0);
		this.mCartSquare.load();

		this.mCartTriangle = new BitmapTextureAtlas(this.getTextureManager(), 256, 192, TextureOptions.BILINEAR_PREMULTIPLYALPHA);
		this.mCartTriangleTexture = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mCartTriangle, this, "cart_triangle.png", 0, 0);
		this.mCartTriangle.load();

		this.mCartPentagon = new BitmapTextureAtlas(this.getTextureManager(), 256, 192, TextureOptions.BILINEAR_PREMULTIPLYALPHA);
		this.mCartPentagonTexture = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mCartPentagon, this, "cart_pentagon.png", 0, 0);
		this.mCartPentagon.load();

		this.mDune = new BitmapTextureAtlas(this.getTextureManager(), 1280, 480, TextureOptions.BILINEAR_PREMULTIPLYALPHA);
		this.mDuneTexture = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mDune, this, "dune.png", 0, 0);
		this.mDune.load();

		this.mDuneBackground = new BitmapTextureAtlas(this.getTextureManager(), 1920, 720, TextureOptions.BILINEAR_PREMULTIPLYALPHA);
		this.mDuneBackgroundTexture = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mDuneBackground, this, "dunebackground.png", 0, 0);
		this.mDuneBackground.load();

		this.mButton = new BitmapTextureAtlas(this.getTextureManager(), 512, 256, TextureOptions.BILINEAR_PREMULTIPLYALPHA);
		this.mButtonTexture = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mButton, this, "button_blank.png", 0, 0);
		this.mButton.load();

		this.mWhiteButton = new BitmapTextureAtlas(this.getTextureManager(), 512, 256, TextureOptions.BILINEAR_PREMULTIPLYALPHA);
		this.mWhiteButtonTexture = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mWhiteButton, this, "button_white.png", 0, 0);
		this.mWhiteButton.load();

		this.mRedBar = new BitmapTextureAtlas(this.getTextureManager(), 32, 16, TextureOptions.REPEATING_BILINEAR);
		this.mRedBarTexture = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mRedBar, this, "red_bar.png", 0, 0);
		this.mRedBar.load();

		this.mBlueBar = new BitmapTextureAtlas(this.getTextureManager(), 32, 16, TextureOptions.REPEATING_BILINEAR);
		this.mBlueBarTexture = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mBlueBar, this, "blue_bar.png", 0, 0);
		this.mBlueBar.load();

		this.mChatBackground = new BitmapTextureAtlas(this.getTextureManager(), 480, 720, TextureOptions.BILINEAR_PREMULTIPLYALPHA);
		this.mChatBackTexture = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mChatBackground, this, "whitebackground.png", 0, 0);
		this.mChatBackground.load();

		this.mChatTab = new BitmapTextureAtlas(this.getTextureManager(), 120, 72, TextureOptions.BILINEAR_PREMULTIPLYALPHA);
		this.mChatTabTexture = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mChatTab, this, "tab.png", 0, 0);
		this.mChatTab.load();

		this.mHowToPlay = new BitmapTextureAtlas(this.getTextureManager(), 480, 1600, TextureOptions.BILINEAR_PREMULTIPLYALPHA);
		this.mHowToPlayTexture = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mHowToPlay, this, "howtoplay.png", 0, 0);
		this.mHowToPlay.load(); 

		this.mHowToPlay2 = new BitmapTextureAtlas(this.getTextureManager(), 480, 1600, TextureOptions.BILINEAR_PREMULTIPLYALPHA);
		this.mHowToPlayTexture2 = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mHowToPlay2, this, "howtoplay2.png", 0, 0);
		this.mHowToPlay2.load();

		this.mHowToPlay3 = new BitmapTextureAtlas(this.getTextureManager(), 480, 1600, TextureOptions.BILINEAR_PREMULTIPLYALPHA);
		this.mHowToPlayTexture3 = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mHowToPlay3, this, "howtoplay3.png", 0, 0);
		this.mHowToPlay3.load();

		this.mChicken = new BitmapTextureAtlas(this.getTextureManager(), 256, 256, TextureOptions.BILINEAR_PREMULTIPLYALPHA);
		this.mChickenTexture = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mChicken, this, "chicken.png",0,0);
		this.mChicken.load();

		this.mCow = new BitmapTextureAtlas(this.getTextureManager(), 125, 125, TextureOptions.BILINEAR_PREMULTIPLYALPHA);
		this.mCowTexture = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mCow, this, "cow.png",0,0);
		this.mCow.load();

		this.mNinja1 = new BitmapTextureAtlas(this.getTextureManager(), 200, 200, TextureOptions.BILINEAR_PREMULTIPLYALPHA);
		this.mNinja1Texture = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mNinja1, this, "ninja1.png",0,0);
		this.mNinja1.load();

		this.mNinja2 = new BitmapTextureAtlas(this.getTextureManager(), 200, 200, TextureOptions.BILINEAR_PREMULTIPLYALPHA);
		this.mNinja2Texture = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mNinja2, this, "ninja2.png",0,0);
		this.mNinja2.load();

		this.mFan1 = new BitmapTextureAtlas(this.getTextureManager(), 225, 225, TextureOptions.BILINEAR_PREMULTIPLYALPHA);
		this.mFan1Texture = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mFan1, this, "fan1.png",0,0);
		this.mFan1.load();

		this.mFan2 = new BitmapTextureAtlas(this.getTextureManager(), 256, 256, TextureOptions.BILINEAR_PREMULTIPLYALPHA);
		this.mFan2Texture = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mFan2, this, "fan2.png",0,0);
		this.mFan2.load();

		this.mWand1 = new BitmapTextureAtlas(this.getTextureManager(), 256, 256, TextureOptions.BILINEAR_PREMULTIPLYALPHA);
		this.mWand1Texture = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mWand1, this, "magicwand1.png",0,0);
		this.mWand1.load();

		this.mWand2 = new BitmapTextureAtlas(this.getTextureManager(), 256, 256, TextureOptions.BILINEAR_PREMULTIPLYALPHA);
		this.mWand2Texture = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mWand2, this, "magicwand2.png",0,0);
		this.mWand2.load();

		this.mLeatherBackground = new BitmapTextureAtlas(this.getTextureManager(), 1100, 850, TextureOptions.BILINEAR_PREMULTIPLYALPHA);
		this.mLeatherTexture = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mLeatherBackground, this, "leather_scroll2.png",0,0);
		this.mLeatherBackground.load(); 

		this.mPaperBackground = new BitmapTextureAtlas(this.getTextureManager(), 1023, 601, TextureOptions.BILINEAR);
		this.mPaperTexture = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mPaperBackground, this, "alternative_background.png",0,0);
		this.mPaperBackground.load();

		this.mMoney = new BitmapTextureAtlas(this.getTextureManager(), 256, 256, TextureOptions.BILINEAR);
		this.mMoneyTexture = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mMoney, this, "money2.png",0,0);
		this.mMoney.load();

		this.mCube = new BitmapTextureAtlas(this.getTextureManager(), 300, 360, TextureOptions.BILINEAR);
		this.mCubeTexture = BitmapTextureAtlasTextureRegionFactory.createTiledFromAsset(mCube, this, "cube.png",0,0,5,6);
		this.mCube.load();

//				this.mCube = new BitmapTextureAtlas(this.getTextureManager(),424, 1134, TextureOptions.BILINEAR);
//				this.mCubeTexture = BitmapTextureAtlasTextureRegionFactory.createTiledFromAsset(mCube, this, "pinkie.png",0,0,4,9);
//				this.mCube.load();

		this.mLogo = new BitmapTextureAtlas(this.getTextureManager(), 765, 334, TextureOptions.BILINEAR);
		this.mLogoTexture = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mLogo, this, "logo2.png",0,0);
		this.mLogo.load();


		this.mFontBold = FontFactory.create(this.getFontManager(), this.getTextureManager(), 256, 256, TextureOptions.BILINEAR, Typeface.create(Typeface.DEFAULT, Typeface.BOLD),24);
		this.mFontBold.load(); 

		this.mFont = FontFactory.create(this.getFontManager(), this.getTextureManager(), 256, 256, TextureOptions.BILINEAR, Typeface.create(Typeface.DEFAULT, Typeface.NORMAL),24);
		this.mFont.load();

		this.mSmallFontBold = FontFactory.create(this.getFontManager(), this.getTextureManager(), 256, 256, TextureOptions.BILINEAR, Typeface.create(Typeface.DEFAULT, Typeface.BOLD),16);
		this.mSmallFontBold.load();

		this.mSmallFont = FontFactory.create(this.getFontManager(), this.getTextureManager(), 256, 256, TextureOptions.BILINEAR, Typeface.create(Typeface.DEFAULT, Typeface.NORMAL),16);
		this.mSmallFont.load();

		this.mMediumFontBold = FontFactory.create(this.getFontManager(), this.getTextureManager(), 256, 256, TextureOptions.BILINEAR, Typeface.create(Typeface.DEFAULT, Typeface.BOLD),20);
		this.mMediumFontBold.load();  

		this.mMediumFont = FontFactory.create(this.getFontManager(), this.getTextureManager(), 256, 256, TextureOptions.BILINEAR, Typeface.create(Typeface.DEFAULT, Typeface.NORMAL),20);
		this.mMediumFont.load();

		this.mBigFont = FontFactory.create(this.getFontManager(), this.getTextureManager(), 256, 256, TextureOptions.BILINEAR, Typeface.create(Typeface.DEFAULT, Typeface.NORMAL),32);
		this.mBigFont.load();

		this.mBigFontBold = FontFactory.create(this.getFontManager(), this.getTextureManager(), 256, 256, TextureOptions.BILINEAR, Typeface.create(Typeface.DEFAULT, Typeface.BOLD),32);
		this.mBigFontBold.load();
	}

	@Override
	protected Scene onCreateScene() {
		mRes = this.getResources();

		this.mOwnTribe = new OwnTribeScene(this,mEngine);
		this.mMap = new MapScene(this,mEngine);
		this.mPendingScene = new PendingChallengesScene(this, mEngine);
		this.mInstructionScene = new HowToPlayScene(this);
		//		this.mQuestionsScene = new QuestionsScene(this);

		this.mScene = new MainMenuScene(this,mEngine);
		this.mActiveScene=mScene;
		createChatScene();
		updateHUD(mActiveScene.hasHelpScene());

//		GetStats task = new GetStats();
//		task.execute();
		
		GetStats stats = new GetStats();
		mActiveTask = stats;
		stats.execute();

		return this.mScene;

	}

	public void resetCameraSettings(){
		mZoomCamera.setZoomFactor(1f);
		mZoomCamera.setBoundsEnabled(false);
		mZoomCamera.setCenter(CAMERA_WIDTH/2, CAMERA_HEIGHT/2);
	}

	/**
	 * Called when the player presses the chat-tab, and is used to either hide or show the chat.
	 * @param setVisible
	 */
	public void displayChatInput(final boolean setVisible){
		//		mResPolicy.setChatVisible(setVisible);
		runOnUiThread(new Runnable(){
			@Override
			public void run() {
				if(setVisible){
					mLayout.setVisibility(View.VISIBLE);
				}else{
					mLayout.setVisibility(View.GONE);
				}
			}
		});
	}

	private void createChatScene(){
		mChatHUD = new ChatHUD(this, mEngine);
		mZoomCamera.setHUD(mChatHUD);
	}

	public void startMainMenuScene(){
		isAtMainMenu=true;
		resetCameraSettings();
		mScene.initialize();
		Scene currentScene = (Scene)mActiveScene;
		this.mActiveScene=mScene;
		new TransitionScene(this, mZoomCamera, mEngine, currentScene, mScene);
		updateHUD(mActiveScene.hasHelpScene());
	}


	/**
	 * Called when a battle should start
	 * @param sentChallenge Says whether the player sent or received the challenge. 
	 */
	public void startBattleActivity(boolean sentChallenge){
		startMainMenuScene();
		Intent intent = new Intent(this, BattleActivity.class);
		intent.putExtra(Constants.PARAMETER_SENT_CHALLENGE, true);
		startActivity(intent);
	}

	/**
	 * Called when the player presses the logout-button.
	 */
	public void logOut(){
		//		UserFunctions.stopHeartbeatService(getApplicationContext());
		UserFunctions.logOutUser(getApplicationContext());
		Intent intent = new Intent(getApplicationContext(), LoginActivity.class);
		startActivity(intent);
		finish();
	}


	/**
	 * Called when the player presses the "Challenge Others"-button on the main menu. Starts the scene that displays the map and other players.
	 */
	public void setMapScene(){
		isAtMainMenu=false;
		mMap.startScene();
		transitionScene((Scene)mActiveScene, mMap);
		this.mActiveScene=mMap;
		updateHUD(mActiveScene.hasHelpScene());
	}

	/**
	 * Called when the player presses the "Manage Own Tribe"-button in the main menu. Starts the scene that shows the player the look of his own tribe.
	 */
	public void setOwnTribeScene(){
		isAtMainMenu=false;
		mOwnTribe.initializeScene();
//		new TransitionScene(this,mZoomCamera,mEngine, (Scene)mActiveScene,mOwnTribe);
		transitionScene((Scene)mActiveScene, mOwnTribe);
		this.mActiveScene=mOwnTribe;
		updateHUD(mActiveScene.hasHelpScene());
	}

	/**
	 * Called when the players presses the "Pending Challenges"-button in the main menu. Starts the scene that show received, but unhandled, challenges.
	 */
	public void setPendingChallengesScene(){
		isAtMainMenu=false;
		ArrayList<Challenge> list = UserFunctions.getChallengeList();
		mPendingScene.initialize(list);
//		new TransitionScene(this,mZoomCamera, mEngine, (Scene)mActiveScene, mPendingScene);
		transitionScene((Scene)mActiveScene, mPendingScene);
		this.mActiveScene=mPendingScene;
		updateHUD(mActiveScene.hasHelpScene());
	}

//	/**
//	 * Called when the player presses the "Questions"-button in the main menu. Starts the scene that shows questions they have answered, and gives the
//	 * possibility to access more information about the question.
//	 */
//	public void setQuestionsScene(){
//		isAtMainMenu = false;
//		mQuestionsScene.initialize();
////		new TransitionScene(this, mZoomCamera, mEngine, (Scene)mActiveScene, mQuestionsScene);
//		transitionScene((Scene)mActiveScene, mQuestionsScene);
//		this.mActiveScene=mQuestionsScene;
//		updateHUD(mActiveScene.hasHelpScene());
//	}
	
	public void transitionScene(final Scene activeScene, final Scene pendingScene){
		inMiddleOfTransition=true;
		Rectangle mRect;
		float FADE_TIME = 0.3f;
		final Scene transitionScene=new Scene();
		transitionScene.setBackgroundEnabled(false);
		mRect = new Rectangle(0,0,
				mZoomCamera.getWidth()/mZoomCamera.getZoomFactor(), mZoomCamera.getHeight()/mZoomCamera.getZoomFactor(),
				getVertexBufferObjectManager());
		mRect.setPosition(mZoomCamera.getXMin(), mZoomCamera.getYMin());
		mRect.registerEntityModifier(new SequenceEntityModifier(new AlphaModifier(FADE_TIME,0,1), new AlphaModifier(FADE_TIME,1,0)));
		mRect.setColor(0, 0, 0);
		transitionScene.attachChild(mRect);
		activeScene.setChildScene(transitionScene);

		transitionScene.registerUpdateHandler(new TimerHandler(FADE_TIME, new ITimerCallback() {
			@Override
			public void onTimePassed(final TimerHandler pTimerHandler) {
				mEngine.runSafely(new Runnable() {
					@Override
					public void run() {
						activeScene.detachChild(transitionScene);
						pendingScene.setChildScene(transitionScene);
						mEngine.setScene(pendingScene);
						inMiddleOfTransition=false;
					}
				});
			}
		}));
	}

	/**
	 * Called when the player presses the Help-button in the Main Menu or any other scene in the same Activity. Displays a scene that explains the
	 * current screen.
	 */
	public void setHelpScene(){
		mActiveScene.showHelpScreen();
	}

	//	public void setInstructionScene(){
	//		isAtMainMenu=false;
	//		new TransitionScene(this,mZoomCamera, mEngine, (Scene)mActiveScene, mInstructionScene);
	//		this.mActiveScene=mInstructionScene;
	//		updateHUD(mActiveScene.hasHelpScene());
	//	}

	/**
	 * Updates HUD to either show or hide the Help-button, depending on whether the current scene has an available Help-screen.
	 * @param show Whether the Help-button should be visible or hidden.
	 */
	public void updateHUD(boolean show){
		mChatHUD.showHelpButton(show);
	}

	/**
	 * Creates the scene where a player sets up a challenge to send to an opponent. 
	 * @param playerNr Index of the player in the list containing close players
	 * @param player The Player-object containing necessary information to send the challenge.
	 */
	public void createChallengeScene(int playerNr, Player player){
		QuestionCategoriesGetter getter = new QuestionCategoriesGetter();
		mActiveTask = getter;
		getter.execute();
		mZoomCamera.setBoundsEnabled(false);
		this.mChallengeScene = new ChallengeScene(this,mEngine, playerNr, player);
		this.mChallengeScene.initialize();
//		new TransitionScene(this,mZoomCamera, mEngine, (Scene)mActiveScene, mChallengeScene);
		transitionScene((Scene)mActiveScene, mChallengeScene);
		this.mActiveScene=mChallengeScene;
		updateHUD(mActiveScene.hasHelpScene());
	}

	/**
	 * When a player has finished setting up a challenge, this method handles sending the challenge to the server.
	 * @param player Player-object representing the opponent
	 * @param x x-coordinate for where the player is attacking
	 * @param y y-coordinate for where the player is attacking
	 * @param size Number of questions in the battle
	 * @param category Category of the questions in the battle
	 */
	public void sendChallenge(Player player, int x, int y, int size, int category){
		String risk = UserFunctions.createRisk(this, player, x, y);
		UserFunctions.setUserBusy(getApplicationContext(), true);
		ChallengeSender sender = new ChallengeSender(risk, size,category);
		mActiveTask = sender;
		sender.execute(player);
		startBattleActivity(true);

	}

	/**
	 * If the player receives a challenge, this method starts the Activity that displays information about the received challenge.
	 * @param c Challenge-object containing information about the received challenge.
	 */
	public void startReceiveChallenge(Challenge c){
		UserFunctions.removeChallengeNotification(this, c.getBattleNr());
		UserFunctions.removeChallengeFromList(c.getBattleNr());
		startMainMenuScene();
		Intent intent = new Intent(getApplicationContext(), ReceiveChallengeActivity.class);
		intent.putExtra(Constants.PARAMETER_BATTLENR, c.getBattleNr());
		intent.putExtra(Constants.PARAMETER_CATEGORY, c.getCategory());
		startActivity(intent);
	}

	public void updateBusyText(){
		mScene.initialize();
	}

	/**
	 * Launches a background thread that contacts the server and gets updated stats for the player.
	 */
	public void updateStats(){
//		GetStats stats = new GetStats();
//		stats.execute();
		GetStats task = new GetStats();
		mActiveTask = task;
		task.execute();
	}

	/**
	 * Starts the browser and shows a site that displays information about a specific question.
	 * @param address URL for the site to be shown.
	 */
	public void startBrowser(String address){
		Intent i = new Intent(Intent.ACTION_VIEW);
		i.setData(Uri.parse(address));
		startActivity(i);
	}

	/**
	 * Displays a loading-animation during necessary background processes, like asking the server for information.
	 * @param show
	 */
	public void displayLoadingAnimation(boolean show){
		mChatHUD.displayLoadingAnimation(show);
	}

	/**
	 * Creates dialog-list that shows the available Categories for a quiz-battle.
	 */
	public void createList(){
		AlertDialog.Builder builder = new AlertDialog.Builder(this);
		builder.setTitle("Select Category");

		final ListView modeList = new ListView(this);
		modeList.setOnItemClickListener(new OnItemClickListener() {

			@Override
			public void onItemClick(AdapterView<?> arg0, View arg1, int arg2,
					long arg3) {
				mChallengeScene.setSelectedCategory(mInt[arg2], mString[arg2]);
				mDialog.dismiss();
			}
		});
		//		String[] stringArray = new String[] { "Bright Mode", "Normal Mode" };
		ArrayAdapter<String> modeAdapter = new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1, android.R.id.text1, mString);
		modeList.setAdapter(modeAdapter);

		builder.setView(modeList);
		mDialog = builder.create();
	}

	/**
	 * Shows the dialog that allows the player to choose Category for a quiz-battle
	 */
	public void showDialog(){
		runOnUiThread(new Runnable() {

			@Override
			public void run() {
				mDialog.show();

			}
		});
	}

	public void getQuestionCategories(){

	}


	/**
	 * Background thread that gets updated stats from the server.
	 * @author Adrian
	 *
	 */
	private class GetStats extends AsyncTask<Void, Void, String>{

		@Override
		protected void onPreExecute() {
			displayLoadingAnimation(true);
		}
		@Override
		protected String doInBackground(Void... params) {
			String result="";
			try {
				do{
					result =Server.getOwnStats(getApplicationContext());
					if(result.equals(Constants.HTTP_EXECUTE_FAILURE)){
						publishProgress();
						Thread.sleep(Constants.STANDARD_CONNECTION_WAIT_TIME);
					}
				}while(result.equals(Constants.HTTP_EXECUTE_FAILURE));
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			return result;
		}

		@Override
		protected void onProgressUpdate(Void... values) {
			Toast.makeText(getApplicationContext(), "Could not contact server. Trying again.", Toast.LENGTH_SHORT).show();
		}

		@Override
		protected void onPostExecute(String result){
			SharedPreferences settings = getApplicationContext().getSharedPreferences(Constants.SHAREDPREFERENCES_NAME, 0);

			JSONObject obj;
			try {
				obj = new JSONObject(result);
				String name = settings.getString(Constants.PARAMETER_ACCOUNT, "");
				String area = obj.getString(Constants.PLAYER_AREA);
				int gold = Integer.parseInt(obj.getString(Constants.PLAYER_GOLD));
				boolean busy = obj.getBoolean(Constants.PARAMETER_BUSY);
				Player temp = new Player(name, area, gold);
				UserFunctions.self=temp;
				UserFunctions.setUserBusy(getApplicationContext(), busy);
				displayLoadingAnimation(false);

			} catch (JSONException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

			mScene.initialize();
		}

	}


	/**
	 * Background thread that sends a challenge.
	 * @author Adrian
	 *
	 */
	private class ChallengeSender extends AsyncTask<Player, Void, String>{

		String risk;
		int size;
		int category;

		public ChallengeSender(String r, int s, int c){
			risk=r;
			size=s;
			category=c;
		}

		@Override
		protected String doInBackground(Player... params) {
			String result="";
			try {
				do{
					result = Server.sendChallenge(params[0].getName(), risk,size,category, getApplicationContext());
					if(result.equals(Constants.HTTP_EXECUTE_FAILURE)){
						publishProgress();
						Thread.sleep(Constants.STANDARD_CONNECTION_WAIT_TIME);
					}
				}while(result.equals(Constants.HTTP_EXECUTE_FAILURE));
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			return result;
		}

		@Override
		protected void onPostExecute(String result){
			if(result.equals(Constants.SERVER_RESPONSE_PLAYER_BUSY)){
				Toast.makeText(getApplicationContext(), result, Toast.LENGTH_LONG).show();
				UserFunctions.setUserBusy(getApplicationContext(), false);
			}else{
				Toast.makeText(getApplicationContext(), "Challenge sent", Toast.LENGTH_LONG).show();
			}
		}
		
		@Override
		protected void onCancelled(String result) {
			
		}

	}

	/**
	 * Background thread that gets the list of available question-categories from the server.
	 * @author Adrian
	 *
	 */
	private class QuestionCategoriesGetter extends AsyncTask<Void, Void, String>{

		@Override
		protected void onPreExecute() {
			displayLoadingAnimation(true);
		}
		@Override
		protected String doInBackground(Void... params) {
			String result="";
			try {
				do{
					result = Server.getQuestionCategories(getApplicationContext());
					if(result.equals(Constants.HTTP_EXECUTE_FAILURE)){
						publishProgress();
						Thread.sleep(Constants.STANDARD_CONNECTION_WAIT_TIME);
					}
				}while(result.equals(Constants.HTTP_EXECUTE_FAILURE));
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			return result;
		}

		@Override
		protected void onProgressUpdate(Void... values) {
			Toast.makeText(getApplicationContext(), "Could not contact server. Trying again.", Toast.LENGTH_SHORT).show();
		}

		@Override
		protected void onPostExecute(String result) {
			try {
				JSONArray ar = new JSONArray(result);
				mString = new String[ar.length()];
				mInt = new int[ar.length()];
				for(int i=0;i<ar.length();i++){
					mString[i] = ar.getJSONObject(i).getString("name");
					mInt[i] = ar.getJSONObject(i).getInt("id");
				}
				createList();
				displayLoadingAnimation(false);
			} catch (JSONException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}

	@Override
	public void onBackPressed() {
		if(!isAtMainMenu){
			if(!mActiveScene.onBackButtonPressed()&&!inMiddleOfTransition){
				this.startMainMenuScene();
				isAtMainMenu=true;
			}		
		}else if(mChatHUD.isDisplayingChat()){
			mChatHUD.hideChat();
		}else if(!mActiveScene.onBackButtonPressed()){
			if(mActiveTask!=null){
				mActiveTask.cancel(true);
			}
			super.onBackPressed();
		}
	}

	@Override
	protected void onPause() {
		//		mQuestionDatabase.closeDatabase();
		super.onPause();
	}
	
	@Override
	protected void onDestroy() {
		if(mActiveTask!=null){
			mActiveTask.cancel(true);
		}
		super.onDestroy();
	}

	@Override
	protected synchronized void onResume() {
		//		mQuestionDatabase.open();
		super.onResume();
	}

	public static void startRound(Context context, Intent intent){
		context.startActivity(intent);
	}

}
