package adrian.master.knowledgewar.gameconcepts;

/**
 * Class that stores information about a single weapon. Information like cost, description, necessary Building-rank, etc.
 * @author Adrian
 *
 */
public class Weapon {
	
	private String mClass;
	private int mRank;
	private String mName;
	private String mDesc, mAttackDesc;
	private int mValue;
	
	/**
	 * Constructor used to create Weapon-templates, that can later be copied to create specific Weapon-objects.
	 * @param wclass
	 * @param rank
	 * @param name
	 * @param desc
	 * @param attackdesc
	 * @param value
	 */
	public Weapon(String wclass, int rank, String name, String desc,String attackdesc, int value){
		this.mClass = wclass;
		this.mRank = rank;
		this.mName = name;
		this.mDesc = desc;
		this.mValue = value;
		this.mAttackDesc = attackdesc;
	}
	
	/**
	 * Copy constructor to create a copy of a weapon-template.
	 * @param w
	 * @return
	 */
	public static Weapon getNewWeapon(Weapon w){
		return new Weapon(w.getmClass(), w.getmRank(), w.getmName(), w.getmDesc(),w.getmAttackDesc(), w.getmValue());
	}
	
	public String getmClass() {
		return mClass;
	}

	public int getmRank() {
		return mRank;
	}

	public String getmName() {
		return mName;
	}

	public String getmDesc() {
		return mDesc;
	}
	
	public String getmAttackDesc(){
		return mAttackDesc;
	}

	public int getmValue() {
		return mValue;
	}

	

}
