package adrian.master.knowledgewar.helpscenes;

import org.andengine.entity.scene.Scene;
import org.andengine.entity.sprite.Sprite;
import org.andengine.entity.text.AutoWrap;
import org.andengine.entity.text.Text;
import org.andengine.entity.text.TextOptions;
import org.andengine.util.HorizontalAlign;

import adrian.master.knowledgewar.R;
import adrian.master.knowledgewar.gameactivities.MainActivity;
import adrian.master.knowledgewar.logic.Constants;

public class ChallengeHelpScene extends Scene {
	
	private MainActivity mParent;
	private Sprite mBackground;
	
	public ChallengeHelpScene(MainActivity parent){
		mParent = parent;

		mBackground = new Sprite(0,0,Constants.CAMERA_WIDTH, Constants.CAMERA_HEIGHT, mParent.mDuneTexture, mParent.getVertexBufferObjectManager());
		attachChild(mBackground);
		
		setupText();
	}
	
	private void setupText(){
		TextOptions opt = new TextOptions(AutoWrap.WORDS, Constants.CAMERA_WIDTH-Constants.TILE_SIZE, HorizontalAlign.CENTER);
		Text text1 = new Text(Constants.TILE_SIZE/2,20,mParent.mFont,mParent.getString(R.string.helpscene_challengehelp1),opt, mParent.getVertexBufferObjectManager());
		Text text2 = new Text(0,0,mParent.mFont,mParent.getString(R.string.helpscene_challengehelp2),opt, mParent.getVertexBufferObjectManager());
		Text text3 = new Text(0,0,mParent.mFont,mParent.getString(R.string.helpscene_challengehelp3),opt, mParent.getVertexBufferObjectManager());
		Text text4 = new Text(0,0,mParent.mFont,mParent.getString(R.string.helpscene_challengehelp4),opt, mParent.getVertexBufferObjectManager());
		Text text5 = new Text(0,0,mParent.mFont,mParent.getString(R.string.helpscene_challengehelp5),opt, mParent.getVertexBufferObjectManager());
		
		text2.setPosition(Constants.TILE_SIZE/2, text1.getY()+text1.getHeight()+mParent.mFont.getLineHeight());
		text3.setPosition(Constants.TILE_SIZE/2, text2.getY()+text2.getHeight()+mParent.mFont.getLineHeight());
		text4.setPosition(Constants.TILE_SIZE/2, text3.getY()+text3.getHeight()+mParent.mFont.getLineHeight());
		text5.setPosition(Constants.TILE_SIZE/2, text4.getY()+text4.getHeight()+mParent.mFont.getLineHeight());
		
		attachChild(text1);
		attachChild(text2);
		attachChild(text3);
		attachChild(text4);
		attachChild(text5);
	}

}
