package adrian.master.knowledgewar.helpscenes;

import org.andengine.engine.camera.ZoomCamera;
import org.andengine.entity.scene.IOnSceneTouchListener;
import org.andengine.entity.scene.Scene;
import org.andengine.entity.sprite.Sprite;
import org.andengine.entity.text.AutoWrap;
import org.andengine.entity.text.Text;
import org.andengine.entity.text.TextOptions;
import org.andengine.input.touch.TouchEvent;
import org.andengine.input.touch.detector.ScrollDetector;
import org.andengine.input.touch.detector.ScrollDetector.IScrollDetectorListener;
import org.andengine.input.touch.detector.SurfaceScrollDetector;
import org.andengine.util.HorizontalAlign;

import adrian.master.knowledgewar.R;
import adrian.master.knowledgewar.gameactivities.MainActivity;
import adrian.master.knowledgewar.logic.Constants;

public class MainMenuHelpScene extends Scene implements IOnSceneTouchListener, IScrollDetectorListener {

	private SurfaceScrollDetector mScrollDetector;
	private MainActivity mParent;
	private Sprite mBackground;
	private ZoomCamera mCamera;
	private float mTextStartY, mTextEndY, mTextLength;
	private Text text1,text2,text3,text4,text5,text6,text7,text8,text9,text10,text11,text12,text13,text14,text15;

	public MainMenuHelpScene(MainActivity parent){
		mParent = parent;
		mCamera = mParent.mZoomCamera;

		mBackground = new Sprite(0,0,Constants.CAMERA_WIDTH, Constants.CAMERA_HEIGHT, mParent.mDuneTexture, mParent.getVertexBufferObjectManager());
		attachChild(mBackground);

		setupText();

		this.mScrollDetector = new SurfaceScrollDetector(this);
		this.setOnSceneTouchListener(this);
		this.setTouchAreaBindingOnActionDownEnabled(true);
	}

	private void setupText(){
		mTextStartY = 20;
		TextOptions opt = new TextOptions(AutoWrap.WORDS, Constants.CAMERA_WIDTH-Constants.TILE_SIZE, HorizontalAlign.CENTER);
		TextOptions main = new TextOptions(AutoWrap.WORDS, Constants.CAMERA_WIDTH-Constants.TILE_SIZE, HorizontalAlign.LEFT);
		text1 = new Text(Constants.TILE_SIZE/2,mTextStartY,mParent.mBigFontBold,mParent.getString(R.string.helpscene_mainmenuhelp1),opt, mParent.getVertexBufferObjectManager());
		text2 = new Text(0,0,mParent.mFont,mParent.getString(R.string.helpscene_mainmenuhelp2),main, mParent.getVertexBufferObjectManager());
		text3 = new Text(0,0,mParent.mFont,mParent.getString(R.string.helpscene_mainmenuhelp3),main, mParent.getVertexBufferObjectManager());
		text4 = new Text(0,0,mParent.mFont,mParent.getString(R.string.helpscene_mainmenuhelp4),main, mParent.getVertexBufferObjectManager());

		text5 = new Text(0,0,mParent.mFontBold,mParent.getString(R.string.helpscene_mainmenuhelp5),main, mParent.getVertexBufferObjectManager());
		text6 = new Text(0,0,mParent.mFont,mParent.getString(R.string.helpscene_mainmenuhelp6),main, mParent.getVertexBufferObjectManager());
		text7 = new Text(0,0,mParent.mFont,mParent.getString(R.string.helpscene_mainmenuhelp7),main, mParent.getVertexBufferObjectManager());
		text8 = new Text(0,0,mParent.mFont,mParent.getString(R.string.helpscene_mainmenuhelp8),main, mParent.getVertexBufferObjectManager());
		text9 = new Text(0,0,mParent.mFont,mParent.getString(R.string.helpscene_mainmenuhelp9),main, mParent.getVertexBufferObjectManager());
		text10 = new Text(0,0,mParent.mFont,mParent.getString(R.string.helpscene_mainmenuhelp10),main, mParent.getVertexBufferObjectManager());

		text11 = new Text(0,0,mParent.mFontBold,mParent.getString(R.string.helpscene_mainmenuhelp11),main, mParent.getVertexBufferObjectManager());
		text12 = new Text(0,0,mParent.mFont,mParent.getString(R.string.helpscene_mainmenuhelp12),main, mParent.getVertexBufferObjectManager());
		text13 = new Text(0,0,mParent.mFont,mParent.getString(R.string.helpscene_mainmenuhelp13),main, mParent.getVertexBufferObjectManager());
		text14 = new Text(0,0,mParent.mFont,mParent.getString(R.string.helpscene_mainmenuhelp14),main, mParent.getVertexBufferObjectManager());
		text15 = new Text(0,0,mParent.mFont,mParent.getString(R.string.helpscene_mainmenuhelp15),main, mParent.getVertexBufferObjectManager());


		text2.setPosition(Constants.TILE_SIZE/2, text1.getY()+text1.getHeight()+mParent.mFont.getLineHeight());
		text3.setPosition(Constants.TILE_SIZE/2, text2.getY()+text2.getHeight()+mParent.mFont.getLineHeight());
		text4.setPosition(Constants.TILE_SIZE/2, text3.getY()+text3.getHeight()+mParent.mFont.getLineHeight());

		text5.setPosition(Constants.TILE_SIZE/2, text4.getY()+text4.getHeight()+mParent.mFont.getLineHeight());
		text6.setPosition(Constants.TILE_SIZE/2, text5.getY()+text5.getHeight());
		text7.setPosition(Constants.TILE_SIZE/2, text6.getY()+text6.getHeight());
		text8.setPosition(Constants.TILE_SIZE/2, text7.getY()+text7.getHeight());
		text9.setPosition(Constants.TILE_SIZE/2, text8.getY()+text8.getHeight());
		text10.setPosition(Constants.TILE_SIZE/2, text9.getY()+text9.getHeight());

		text11.setPosition(Constants.TILE_SIZE/2, text10.getY()+text10.getHeight()+mParent.mFont.getLineHeight());
		text12.setPosition(Constants.TILE_SIZE/2, text11.getY()+text11.getHeight());
		text13.setPosition(Constants.TILE_SIZE/2, text12.getY()+text12.getHeight());
		text14.setPosition(Constants.TILE_SIZE/2, text13.getY()+text13.getHeight());

		text15.setPosition(Constants.TILE_SIZE/2, text14.getY()+text14.getHeight()+2*mParent.mFont.getLineHeight());
		
		mTextEndY = text15.getY()+text15.getHeight();
		mTextLength = mTextEndY - mTextStartY;

		attachChild(text1);
		attachChild(text2);
		attachChild(text3);
		attachChild(text4);
		attachChild(text5);
		attachChild(text6);
		attachChild(text7);
		attachChild(text8);
		attachChild(text9);
		attachChild(text10);
		attachChild(text11);
		attachChild(text12);
		attachChild(text13);
		attachChild(text14);
		attachChild(text15);
	}

	private void updateTextPositions(){
		text1.setPosition(Constants.TILE_SIZE/2,mTextStartY);
		text2.setPosition(Constants.TILE_SIZE/2, text1.getY()+text1.getHeight()+mParent.mFont.getLineHeight());
		text3.setPosition(Constants.TILE_SIZE/2, text2.getY()+text2.getHeight()+mParent.mFont.getLineHeight());
		text4.setPosition(Constants.TILE_SIZE/2, text3.getY()+text3.getHeight()+mParent.mFont.getLineHeight());

		text5.setPosition(Constants.TILE_SIZE/2, text4.getY()+text4.getHeight()+mParent.mFont.getLineHeight());
		text6.setPosition(Constants.TILE_SIZE/2, text5.getY()+text5.getHeight());
		text7.setPosition(Constants.TILE_SIZE/2, text6.getY()+text6.getHeight());
		text8.setPosition(Constants.TILE_SIZE/2, text7.getY()+text7.getHeight());
		text9.setPosition(Constants.TILE_SIZE/2, text8.getY()+text8.getHeight());
		text10.setPosition(Constants.TILE_SIZE/2, text9.getY()+text9.getHeight());

		text11.setPosition(Constants.TILE_SIZE/2, text10.getY()+text10.getHeight()+mParent.mFont.getLineHeight());
		text12.setPosition(Constants.TILE_SIZE/2, text11.getY()+text11.getHeight());
		text13.setPosition(Constants.TILE_SIZE/2, text12.getY()+text12.getHeight());
		text14.setPosition(Constants.TILE_SIZE/2, text13.getY()+text13.getHeight());

		text15.setPosition(Constants.TILE_SIZE/2, text14.getY()+text14.getHeight()+2*mParent.mFont.getLineHeight());
		
		mTextEndY = text15.getY()+text15.getHeight();
	}

	@Override
	public void onScrollStarted(ScrollDetector pScollDetector, int pPointerID,
			float pDistanceX, float pDistanceY) {
		// TODO Auto-generated method stub

	}

	@Override
	public void onScroll(ScrollDetector pScollDetector, int pPointerID,
			float pDistanceX, float pDistanceY) {
		float y = pDistanceY/mCamera.getZoomFactor();
		if(mTextStartY+y<=20 && mTextEndY>=(MainActivity.CAMERA_HEIGHT-Constants.TILE_SIZE)){
			mTextStartY+=y;
		}else if(mTextStartY>20){
			mTextStartY =20;
		}else if(mTextEndY < (MainActivity.CAMERA_HEIGHT-Constants.TILE_SIZE)){
			mTextStartY = (MainActivity.CAMERA_HEIGHT - Constants.TILE_SIZE) - mTextLength;
		}
		updateTextPositions();
	}

	@Override
	public void onScrollFinished(ScrollDetector pScollDetector, int pPointerID,
			float pDistanceX, float pDistanceY) {
		// TODO Auto-generated method stub

	}

	@Override
	public boolean onSceneTouchEvent(Scene pScene, TouchEvent pSceneTouchEvent) {
		this.mScrollDetector.onTouchEvent(pSceneTouchEvent);
		return true;
	}

}
