package adrian.master.knowledgewar.interfaces;

/**
 * Interface used by all scenes that are part of the MainActivity. This is because the MainActivity keeps track of the state of HUD and 
 * what scenes are active. If the Back-button is pressed, the Activity can just send the buttonpress to whatever scene is active instead of 
 * micromanaging the active scenes.
 * @author Adrian
 *
 */
public interface MainActivityInterface {
	
	public boolean onBackButtonPressed();
	public void showHelpScreen();
	public boolean hasHelpScene();

}
