package adrian.master.knowledgewar.logic;

/**
 * Class containing all constants used by the game.
 * @author Adrian
 *
 */
public class Constants {
	public static final String SENDER_ID = "813875255827";
	public static final long GPS_POLLING_PERIOD = 300000;
	public static final int CAMERA_HEIGHT = 800;
	public static final int CAMERA_HEIGHT_MINUS_TEXT = 720;
	public static final int CAMERA_WIDTH = 480;
	public static final float CLOSE_PLAYER = 0.05f;
	
	public static final int TILE_SIZE = 64;
	public static final String[] BUILDING_TYPES = {"A", "B", "C", "D", "E", "F"}; 
	public static final int BASELINE_SCORE = 100;
	public static final int BASELINE_TIMER = 20;
	public static final int NUMBER_OF_PLAYERS_ON_MAP = 100;
	public static final float BUTTONPRESSED_SCALE = 1.25f;
	public static final int DEFAULT_WIN_TIMEOUT = 60;
	public static final int STANDARD_CONNECTION_WAIT_TIME = 3000;
	
	public static final String SERVER_ADDRESS = "http://?:10078/KnowledgeWarServer/";
//	public static final String SERVER_ADDRESS = "http://192.168.0.197:10078/KnowledgeWarServer/";
//	public static final String SERVER_ADDRESS = "http://192.168.0.188:10078/KnowledgeWarServer/";
	public static final String LOGIN_SERVLET = SERVER_ADDRESS+"LoginServlet";
	public static final String GCM_SERVLET = SERVER_ADDRESS+"GCMServlet";
	public static final String PLAYER_SERVLET = SERVER_ADDRESS+"PlayerServlet";
	public static final String BATTLE_SERVLET = SERVER_ADDRESS+"BattleServlet";
	public static final String CHALLENGE_SERVLET = SERVER_ADDRESS+"ChallengeServlet";
	public static final String CHAT_SERVLET = SERVER_ADDRESS+"ChatServlet";
	public static final String HTTP_EXECUTE_FAILURE = "http_failure";
	
	//Possible messages sent by the server
	public static final String SERVER_RESPONSE_LOGIN_SUCCESSFUL = "login_success";
	public static final String SERVER_RESPONSE_LOGIN_FAILURE = "login_failure";
	public static final String SERVER_RESPONSE_REGISTRATION_SUCCESSFUL = "registration_success";
	public static final String SERVER_RESPONSE_REGISTRATION_FAILURE = "registration_failure";
	public static final String SERVER_RESPONSE_BATTLEOVER = "battle_over";
	public static final String SERVER_RESPONSE_WAITING = "waiting_for_opponent";
	public static final String SERVER_RESPONSE_PLAYER_BUSY = "player_busy";
	public static final String SERVER_RESPONSE_PLAYER_AVAILABLE = "player_available";
	public static final String SERVER_RESPONSE_SUCCESS = "success";
	
	//Names for entries in the Android Shared Preferences
	public static final String SHAREDPREFERENCES_NAME = "login";
	public static final String SHAREDPREFERENCES_LOGGED_IN = "loggedIn";
	public static final String SHAREDPREFERENCES_ACCOUNTNAME = "accountname";
	public static final String SHAREDPREFERENCES_PASSWORD = "password";
	public static final String SHAREDPREFERENCES_X = "x";
	public static final String SHAREDPREFERENCES_Y = "y";
	public static final String SHAREDPREFERENCES_AREA = "area";
	public static final String SHAREDPREFERENCES_GOLD = "gold";
	public static final String SHAREDPREFERENCES_XP = "xp";
	public static final String SHAREDPREFERENCES_BUSY = "busy";
	public static final String SHAREDPREFERENCES_IP = "ip";
	
	//Commands and parameters for communicating with the server
	public static final String COMMAND = "command";
	public static final String COMMAND_REGISTER = "register";
	public static final String COMMAND_LOGIN = "login";
	public static final String COMMAND_LOGOUT = "logout";
	public static final String COMMAND_GETPLAYERS = "getplayers";
	public static final String COMMAND_GETCLOSEPLAYERS = "getcloseplayers";
	public static final String COMMAND_GET_OWN_STATS = "getownstats";
	public static final String COMMAND_VERIFYGCM = "verify_gcm";
	public static final String COMMAND_REGISTERGCM = "register_gcm";
	public static final String COMMAND_CHALLENGE = "challenge";
	public static final String COMMAND_ACCEPT = "accept";
	public static final String COMMAND_DECLINE = "decline";
	public static final String COMMAND_ANSWER = "answer";
	public static final String COMMAND_FINISH = "finish";
	public static final String COMMAND_ISFINISHED = "isfinished";
	public static final String COMMAND_INFO ="battleinfo";
	public static final String COMMAND_BATTLE_RESULT = "battleresult";
	public static final String COMMAND_STARTROUND ="startround";
	public static final String COMMAND_GETQUESTIONS ="getquestions";
	public static final String COMMAND_WAITINGFOROPPONENT = "waitingforopponent";
	public static final String COMMAND_BATTLEOVER = "battleover";
	public static final String COMMAND_UPDATEPOSITION = "updateposition";
	public static final String COMMAND_UPDATESTATS = "updatestats";
	public static final String COMMAND_CHALLENGE_DECLINED = "challengedeclined";
	public static final String COMMAND_CHALLENGE_IMPOSSIBLE = "challengeimpossible";
	public static final String COMMAND_YOU_DECLINED_CHALLENGE = "youdeclinedchallenge";
	public static final String COMMAND_CHAT = "chat";
	public static final String COMMAND_HEARTBEAT = "heartbeat";
	public static final String COMMAND_GETQUESTIONCATEGORIES ="getquestioncategories";
	public static final String COMMAND_PLACEBUILDING = "placebuilding";
	public static final String COMMAND_UPGRADEBUILDING = "upgradebuilding";
	public static final String COMMAND_REMOVEBUILDING = "removebuilding";
	
	public static final String PARAMETER_ACCOUNT = "accountname";
	public static final String PARAMETER_PASSWORD = "password";
	public static final String PARAMETER_LOCATION = "location";
	public static final String PARAMETER_REGID = "regid";
	public static final String PARAMETER_CHALLENGER = "challenger";
	public static final String PARAMETER_CHALLENGEE = "challengee";
	public static final String PARAMETER_RISK = "risk";
	public static final String PARAMETER_SIZE = "size";
	public static final String PARAMETER_BATTLENR = "battlenr";
	public static final String PARAMETER_SELF = "self";
	public static final String PARAMETER_OPPONENT ="opponent";
	public static final String PARAMETER_ATTACK = "attack";
	public static final String PARAMETER_SCORE = "score";
	public static final String PARAMETER_OPPONENTSCORE = "opponentscore";
	public static final String PARAMETER_LATITUDE = "latitude";
	public static final String PARAMETER_LONGITUDE = "longitude";
	public static final String PARAMETER_GOLD = "gold";
	public static final String PARAMETER_AREA = "area";
	public static final String PARAMETER_BUSY = "busy";
	public static final String PARAMETER_RESULT = "result";
	public static final String PARAMETER_WINNER = "winner";
	public static final String PARAMETER_LOSER = "loser";
	public static final String PARAMETER_DRAW = "draw";
	public static final String PARAMETER_PLAYERS = "players";
	public static final String PARAMETER_MESSAGE = "message";
	public static final String PARAMETER_WEAPONCOST = "weaponcost";
	public static final String PARAMETER_CATEGORY="category";
	public static final String PARAMETER_SENT_CHALLENGE="sentchallenge";
	public static final String PARAMETER_BUILDINGTYPE = "buildingtype";
	public static final String PARAMETER_BUILDINGRANK = "buildingrank";
	public static final String PARAMETER_BUILDINGX = "building_x";
	public static final String PARAMETER_BUILDINGY = "building_y";
	
	//Names of columns in the question-table in the database. Used to construct questions locally.
	public static final String QUESTION_KEY = "id";
	public static final String QUESTION_QUESTION = "question";
	public static final String QUESTION_ALT1 = "alt1";
	public static final String QUESTION_ALT2 = "alt2";
	public static final String QUESTION_ALT3 = "alt3";
	public static final String QUESTION_ALT4 = "alt4";
	public static final String QUESTION_CORRECT = "correct_alt";
	public static final String QUESTION_URL = "url";
	
	
	//Codes for attacks by buildings and ranks.
	public static final String ATTACK_BUILDINGB_RANK1 = "B1";
	public static final String ATTACK_BUILDINGB_RANK2 = "B3";
	public static final String ATTACK_BUILDINGC_RANK1 = "C1";
	public static final String ATTACK_BUILDINGC_RANK2 = "C3";
	public static final String ATTACK_BUILDINGD_RANK1 = "D1";
	public static final String ATTACK_BUILDINGD_RANK2 = "D3";
	public static final String ATTACK_BUILDINGE_RANK1 = "E1";
	public static final String ATTACK_BUILDINGE_RANK2 = "E3";
	public static final String ATTACK_BUILDINGF_RANK1 = "F1";
	public static final String ATTACK_BUILDINGF_RANK2 = "F3";
	public static final String ATTACK_NOATTACK = "";
	
	//Database-related constants
	public static final String PLAYER_ACCOUNT = "account";
	public static final String PLAYER_AREA = "area";
	public static final String PLAYER_GOLD = "gold";
	public static final String PLAYER_BUSY = "busy";
}
