package adrian.master.knowledgewar.logic;

import java.util.LinkedList;

import adrian.master.knowledgewar.gameconcepts.Question;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.database.sqlite.SQLiteStatement;

//This class is not currently in use!

public class Database extends SQLiteOpenHelper {

	private static String DATABASE_NAME = "questions";
	private static int DATABASE_VERSION = 1;

	private static String TABLE = "questions";
	private static String ID_COLUMN = "id";
	private static String QUESTION_COLUMN = "question";
	private static String URL_COLUMN = "url";

	private String[] columns = {ID_COLUMN, QUESTION_COLUMN, URL_COLUMN};

	private static String DATABASE_CREATE = "CREATE TABLE "+TABLE+" ("+
			ID_COLUMN+" INTEGER PRIMARY KEY, "+
			QUESTION_COLUMN+" TEXT, "+
			URL_COLUMN+" TEXT);";

	private SQLiteDatabase database;

	private static Database instance;

	private Database(Context context){
		super(context, DATABASE_NAME, null, DATABASE_VERSION);
		instance = this;
	}

//	public static Database getInstance(Context context){
//		if(instance == null){
//			instance = new Database(context);
//		}
//		return instance;
//	}

	@Override
	public void onCreate(SQLiteDatabase database) {
		database.execSQL(DATABASE_CREATE);

	}

	@Override
	public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
		// TODO Auto-generated method stub

	}

	public void open(){
		database = getWritableDatabase();
	}

	public void closeDatabase(){
		database.close();
	}

	public void insertQuestion(Question q){
		String sql = "INSERT OR REPLACE INTO "+TABLE+"("+ID_COLUMN+","+QUESTION_COLUMN+","+URL_COLUMN+") VALUES (?,?,?);";
		SQLiteStatement stmnt = database.compileStatement(sql);
		stmnt.bindDouble(1, q.getId());
		stmnt.bindString(2, q.getQuestion());
		stmnt.bindString(3, q.getURL());
		stmnt.executeInsert();
	}

	public LinkedList<Question> getQuestions(){
		LinkedList<Question> result = new LinkedList<Question>();
		Cursor cursor = database.query(TABLE,
		        columns, null, null,
		        null, null, null);

		cursor.moveToFirst();
	    while (!cursor.isAfterLast()) {
	      int id = cursor.getInt(0);
	      String question = cursor.getString(1);
	      String url = cursor.getString(2);
	      Question q = new Question(id,question,url);
	      result.add(q);
	      cursor.moveToNext();
	    }
		cursor.close();
		return result;
	}

}
