package adrian.master.knowledgewar.scenes;

import org.andengine.entity.scene.Scene;
import org.andengine.entity.scene.background.AutoParallaxBackground;
import org.andengine.entity.scene.background.ParallaxBackground;
import org.andengine.entity.scene.background.ParallaxBackground.ParallaxEntity;
import org.andengine.entity.sprite.Sprite;
import org.andengine.entity.text.AutoWrap;
import org.andengine.entity.text.Text;
import org.andengine.entity.text.TextOptions;
import org.andengine.opengl.texture.region.TextureRegion;
import org.andengine.opengl.vbo.VertexBufferObjectManager;
import org.andengine.util.HorizontalAlign;

import adrian.master.knowledgewar.R;
import adrian.master.knowledgewar.gameactivities.BattleActivity;
import adrian.master.knowledgewar.interfaces.BattleActivityInterface;
import adrian.master.knowledgewar.logic.Constants;

public class ChallengeAcceptedScene extends Scene implements BattleActivityInterface {
	
	private BattleActivity mParent;
	private ParallaxBackground mBackground;
	private TextureRegion mPaper, mLeather;
	private Sprite mLeatherBackground;
	private Text mHeader, mMain;
	private VertexBufferObjectManager mMgr;
	
	public ChallengeAcceptedScene(BattleActivity parent){
		mParent = parent;
		mMgr = mParent.mMgr;
		mLeather=mParent.mLeatherTexture;
		
		createBackground();
		createLeather();
	}
	
	private void createBackground(){
		this.mBackground = new AutoParallaxBackground(0, 0, 0, 5);
		Sprite temp = new Sprite(0, 0, mParent.mBigDuneTexture, mMgr);
		mBackground.attachParallaxEntity(new ParallaxEntity(5, temp));
		this.setBackground(mBackground);
	}
	
	private void createLeather(){
		mLeatherBackground = new Sprite(0,0,Constants.CAMERA_WIDTH - Constants.TILE_SIZE, Constants.CAMERA_HEIGHT/3,mLeather,mMgr);
		mLeatherBackground.setPosition(Constants.CAMERA_WIDTH/2 - mLeatherBackground.getWidth()/2, 50);
		attachChild(mLeatherBackground);

		TextOptions opt = new TextOptions(AutoWrap.WORDS, mLeatherBackground.getWidth()-Constants.TILE_SIZE, HorizontalAlign.CENTER);
		mHeader = new Text(0,0,mParent.mFontBold,mParent.getString(R.string.challengeaccepted_header),opt,mMgr);
		mMain = new Text(0,0,mParent.mFont, mParent.getString(R.string.challengeaccepted_main),opt,mMgr);

		mHeader.setPosition(mLeatherBackground.getWidth()/2-mHeader.getWidth()/2, 60);
		mMain.setPosition(mLeatherBackground.getWidth()/2-mMain.getWidth()/2, mHeader.getY()+mHeader.getHeight()+20);
		mLeatherBackground.attachChild(mHeader);
		mLeatherBackground.attachChild(mMain);
	}

	@Override
	public boolean onBackButtonPressed() {
		// TODO Auto-generated method stub
		return false;
	}

}
