package adrian.master.knowledgewar.scenes;

import org.andengine.entity.scene.IOnSceneTouchListener;
import org.andengine.entity.scene.Scene;
import org.andengine.entity.sprite.Sprite;
import org.andengine.input.touch.TouchEvent;
import org.andengine.input.touch.detector.ScrollDetector;
import org.andengine.input.touch.detector.ScrollDetector.IScrollDetectorListener;
import org.andengine.input.touch.detector.SurfaceScrollDetector;

import adrian.master.knowledgewar.gameactivities.MainActivity;
import adrian.master.knowledgewar.interfaces.MainActivityInterface;
import adrian.master.knowledgewar.logic.Constants;

public class HowToPlayScene extends Scene implements IOnSceneTouchListener, IScrollDetectorListener, MainActivityInterface {

	private MainActivity mParent;
	private Sprite mBackground;
	private Sprite mInstructions,mInstructions2,mInstructions3;
	private ScrollDetector mScrollDetector;

	public HowToPlayScene(MainActivity parent){
		mParent = parent;

		mBackground = new Sprite(0,0,Constants.CAMERA_WIDTH, Constants.CAMERA_HEIGHT, mParent.mDuneTexture, mParent.getVertexBufferObjectManager());
		attachChild(mBackground);

		mInstructions = new Sprite(0,0,mParent.mHowToPlayTexture,mParent.getVertexBufferObjectManager());
		attachChild(mInstructions);
		
		mInstructions2 = new Sprite(0,mInstructions.getY()+mInstructions.getHeight(),mParent.mHowToPlayTexture2,mParent.getVertexBufferObjectManager());
		attachChild(mInstructions2);
		
		mInstructions3 = new Sprite(0,mInstructions2.getY()+mInstructions2.getHeight(),mParent.mHowToPlayTexture3,mParent.getVertexBufferObjectManager());
		attachChild(mInstructions3);
//		mInstructions.setAlpha(0.5f);

		this.mScrollDetector = new SurfaceScrollDetector(this);
		setOnSceneTouchListener(this);

	}

	@Override
	public boolean onSceneTouchEvent(Scene pScene, TouchEvent pSceneTouchEvent) {

		if(pSceneTouchEvent.isActionDown()) {
			this.mScrollDetector.setEnabled(true);
		}
		this.mScrollDetector.onTouchEvent(pSceneTouchEvent);

		return true;
	}

	@Override
	public void onScrollStarted(ScrollDetector pScollDetector, int pPointerID,
			float pDistanceX, float pDistanceY) {
		// TODO Auto-generated method stub

	}

	@Override
	public void onScroll(ScrollDetector pScollDetector, int pPointerID,
			float pDistanceX, float pDistanceY) {
		mInstructions.setPosition(mInstructions.getX(), mInstructions.getY()+pDistanceY);
		mInstructions2.setPosition(mInstructions2.getX(), mInstructions2.getY()+pDistanceY);
		mInstructions3.setPosition(mInstructions3.getX(), mInstructions3.getY()+pDistanceY);

	}

	@Override
	public void onScrollFinished(ScrollDetector pScollDetector, int pPointerID,
			float pDistanceX, float pDistanceY) {
		mInstructions.setPosition(mInstructions.getX(), mInstructions.getY()+pDistanceY);
		mInstructions2.setPosition(mInstructions2.getX(), mInstructions2.getY()+pDistanceY);
		mInstructions3.setPosition(mInstructions3.getX(), mInstructions3.getY()+pDistanceY);

	}

	@Override
	public boolean onBackButtonPressed() {
		return false;
	}

	@Override
	public void showHelpScreen() {
		// TODO Auto-generated method stub
	}

	@Override
	public boolean hasHelpScene() {
		// TODO Auto-generated method stub
		return false;
	}

}
