package adrian.master.knowledgewar.scenes;

import org.andengine.engine.Engine;
import org.andengine.engine.camera.ZoomCamera;
import org.andengine.engine.handler.timer.ITimerCallback;
import org.andengine.engine.handler.timer.TimerHandler;
import org.andengine.entity.modifier.AlphaModifier;
import org.andengine.entity.modifier.SequenceEntityModifier;
import org.andengine.entity.primitive.Rectangle;
import org.andengine.entity.scene.Scene;
import org.andengine.opengl.vbo.VertexBufferObjectManager;
import org.andengine.ui.activity.BaseGameActivity;

public class TransitionScene extends Scene {

	private Rectangle mRect;
	private BaseGameActivity mParent;
	private VertexBufferObjectManager mMgr;
	private Scene mOldScene, mNewScene;
	private Engine mEngine;
	private float FADE_TIME = 0.3f;
	private float mCameraWidth, mCameraHeight;

	public TransitionScene(BaseGameActivity parent, ZoomCamera cam, Engine eng, Scene oldScene, Scene newScene){
		
		mParent = parent;
		mMgr = mParent.getVertexBufferObjectManager();
		mEngine = eng;
		setBackgroundEnabled(false);
		mOldScene = oldScene;
		mNewScene = newScene;
		mCameraHeight = cam.getHeight()/cam.getZoomFactor();
		mCameraWidth=cam.getWidth()/cam.getZoomFactor();
		mRect = new Rectangle(0,0,mCameraWidth, mCameraHeight,mMgr);
		mRect.setPosition(cam.getXMin(), cam.getYMin());
		mRect.registerEntityModifier(new SequenceEntityModifier(new AlphaModifier(FADE_TIME,0,1), new AlphaModifier(FADE_TIME,1,0)));
		mRect.setColor(0, 0, 0);
		attachChild(mRect);
		mOldScene.setChildScene(this);

		this.registerUpdateHandler(new TimerHandler(FADE_TIME, new ITimerCallback() {
			@Override
			public void onTimePassed(final TimerHandler pTimerHandler) {
				mEngine.runSafely(new Runnable() {
					@Override
					public void run() {
						mOldScene.detachChild(TransitionScene.this);
						mNewScene.setChildScene(TransitionScene.this);
						mEngine.setScene(mNewScene);
						
					}
				});
			}
		}));
	}

}
