package adrian.master.knowledgewar.subscenes;

import org.andengine.engine.camera.hud.HUD;
import org.andengine.entity.sprite.AnimatedSprite;
import org.andengine.entity.sprite.Sprite;
import org.andengine.opengl.texture.region.TextureRegion;
import org.andengine.opengl.texture.region.TiledTextureRegion;
import org.andengine.opengl.vbo.VertexBufferObjectManager;
import org.andengine.ui.activity.SimpleBaseGameActivity;

import adrian.master.knowledgewar.logic.Constants;

public class LoadingHUD extends HUD {
	
	private SimpleBaseGameActivity mParent;
	private TextureRegion mBlackTexture;
	private TiledTextureRegion mCube;
	private Sprite mBackground;
	private AnimatedSprite mAnimatedCube;
	private VertexBufferObjectManager mMgr;
	
	public LoadingHUD(TextureRegion black, TiledTextureRegion cube, VertexBufferObjectManager mgr){
		mBlackTexture = black;
		mCube = cube;
		mMgr = mgr;
		
		createBackground();
//		createCube();
		
		mBackground.setVisible(false);
		
	}

	private void createBackground(){
//		mBlackTexture.setTextureSize(Constants.CAMERA_WIDTH, Constants.CAMERA_HEIGHT);
//		mBackground = new Sprite(0,0,mBlackTexture,mMgr);
//		mBackground.setAlpha(0.5f);
//		attachChild(mBackground);
		
//		this.mBlackBackgroundTexture = mParent.mBlackTexture;
//		this.mCubeTexture = mParent.mCubeTexture;
		
		this.mAnimatedCube = new AnimatedSprite(0, 0, mCube, mMgr);
		this.mAnimatedCube.setPosition(Constants.CAMERA_WIDTH/2 - this.mCube.getWidth()/2, Constants.CAMERA_HEIGHT/2 - this.mCube.getHeight()/2);
		this.mAnimatedCube.setScale(2);
		
		this.mBlackTexture.setTextureSize(Constants.CAMERA_WIDTH, Constants.CAMERA_HEIGHT);
		this.mBackground = new Sprite(0,0,mBlackTexture,mMgr);
		this.mBackground.setAlpha(0.5f);
		mBackground.attachChild(mAnimatedCube);
		attachChild(mBackground);
		
		this.mBackground.setVisible(false);
	}
	
//	private void createCube(){
//		mAnimatedCube = new AnimatedSprite(0,0,mCube,mMgr);
//		mAnimatedCube.setPosition(Constants.CAMERA_WIDTH/2-mAnimatedCube.getWidth()/2, Constants.CAMERA_HEIGHT/2 - mAnimatedCube.getHeight()/2);
//		mBackground.attachChild(mAnimatedCube);
//	}
	
	public void displayLoadingAnimation(boolean show){
		mBackground.setVisible(show);
		if(show){
			mAnimatedCube.animate(100);
		}else{
			mAnimatedCube.stopAnimation();
		}
	}
}
