package adrian.master.knowledgewar.subscenes;

import org.andengine.entity.scene.Scene;
import org.andengine.entity.sprite.Sprite;
import org.andengine.entity.text.AutoWrap;
import org.andengine.entity.text.Text;
import org.andengine.entity.text.TextOptions;
import org.andengine.input.touch.TouchEvent;
import org.andengine.opengl.texture.region.TextureRegion;
import org.andengine.opengl.vbo.VertexBufferObjectManager;
import org.andengine.util.HorizontalAlign;

import adrian.master.knowledgewar.gameactivities.MainActivity;
import adrian.master.knowledgewar.gameconcepts.Weapon;
import adrian.master.knowledgewar.logic.Constants;

public class WeaponSubMenu extends Scene {
	
	private Weapon mWeapon;
	private Sprite mWindow, mBackground;
	private TextureRegion mLeather;
	private VertexBufferObjectManager mMgr;
	private MainActivity mParent;
	private int CAMERA_HEIGHT = Constants.CAMERA_HEIGHT, CAMERA_WIDTH=Constants.CAMERA_WIDTH;
	
	public WeaponSubMenu(MainActivity parent,Weapon w){
		mParent=parent;
		mMgr=mParent.getVertexBufferObjectManager();
		mLeather = mParent.mLeatherTexture;
		mWeapon = w;
		createBackground();
		createWindow();
		createText();
		this.setBackgroundEnabled(false);
		this.setOnAreaTouchTraversalFrontToBack();
	}
	
	private void createWindow(){
		mWindow = new Sprite(0,0, CAMERA_WIDTH-Constants.TILE_SIZE*2, Constants.TILE_SIZE*4, mLeather,mMgr){
			@Override
			public boolean onAreaTouched(TouchEvent pSceneTouchEvent,
					float pTouchAreaLocalX, float pTouchAreaLocalY) {
				return true;
			}
		};
		mWindow.setPosition(CAMERA_WIDTH/2-mWindow.getWidth()/2, CAMERA_HEIGHT/2-mWindow.getHeight()/2);
		attachChild(mWindow);
		registerTouchArea(mWindow);
	}
	
	private void createBackground(){
		TextureRegion mBlack = mParent.mBlackTexture;
		mBlack.setTextureSize(Constants.CAMERA_WIDTH, Constants.CAMERA_HEIGHT);
		mBackground=new Sprite(0,0,mBlack,mMgr){
			@Override
			public boolean onAreaTouched(TouchEvent pSceneTouchEvent,
					float pTouchAreaLocalX, float pTouchAreaLocalY) {
				((GeneralBuildingSubMenu)mParentScene).removeSubMenu();
				return true;
			}
		};
		mBackground.setAlpha(0.3f);
		attachChild(mBackground);
		registerTouchArea(mBackground);
	}
	
	public void createText(){
		TextOptions main = new TextOptions(AutoWrap.WORDS, mWindow.getWidth()-80, HorizontalAlign.CENTER, Text.LEADING_DEFAULT);
		String name = mWeapon.getmName();
		String desc = mWeapon.getmDesc();
		int cost = mWeapon.getmValue();
		
		float x_padding = 40;
		float yCoord = 40;
		
		Text wName = new Text(x_padding,yCoord,mParent.mFontBold, name, main, mMgr);
		Text wDesc = new Text(x_padding,yCoord+2*mParent.mFontBold.getLineHeight(),mParent.mSmallFont, desc, main, mMgr);
		Text wCost = new Text(x_padding,wDesc.getY()+wDesc.getHeight()+mParent.mSmallFont.getLineHeight(), mParent.mSmallFont, "Cost: "+cost, main, mMgr);
		
		mWindow.attachChild(wName);
		mWindow.attachChild(wDesc);
		mWindow.attachChild(wCost);
	}

}
